import '../beevoter_common.dart';

class IEmailProvider {}
class ISMSProvider {}

// Enum type
class AdministratorPermission {
	int value;
	AdministratorPermission({this.value});
	void clear() { value = 0; }
	bool isNoAdmin() { return value & 0 != 0; }
	void setNoAdmin() { value = value & 0; }
	static AdministratorPermission noAdmin() { return new AdministratorPermission(value: 0); }
	bool isUploadConf() { return value & 1 != 0; }
	void setUploadConf() { value = value & 1; }
	static AdministratorPermission uploadConf() { return new AdministratorPermission(value: 1); }
	bool isUploadVoter() { return value & 2 != 0; }
	void setUploadVoter() { value = value & 2; }
	static AdministratorPermission uploadVoter() { return new AdministratorPermission(value: 2); }
	bool isDownloadResult() { return value & 4 != 0; }
	void setDownloadResult() { value = value & 4; }
	static AdministratorPermission downloadResult() { return new AdministratorPermission(value: 4); }
	bool isPresentialTooglePool() { return value & 8 != 0; }
	void setPresentialTooglePool() { value = value & 8; }
	static AdministratorPermission presentialTooglePool() { return new AdministratorPermission(value: 8); }
	bool isAddVoter() { return value & 16 != 0; }
	void setAddVoter() { value = value & 16; }
	static AdministratorPermission addVoter() { return new AdministratorPermission(value: 16); }
	bool isAddCredentialVoter() { return value & 32 != 0; }
	void setAddCredentialVoter() { value = value & 32; }
	static AdministratorPermission addCredentialVoter() { return new AdministratorPermission(value: 32); }
	bool isAddPoolToVoter() { return value & 64 != 0; }
	void setAddPoolToVoter() { value = value & 64; }
	static AdministratorPermission addPoolToVoter() { return new AdministratorPermission(value: 64); }
	bool isSendPassword() { return value & 128 != 0; }
	void setSendPassword() { value = value & 128; }
	static AdministratorPermission sendPassword() { return new AdministratorPermission(value: 128); }
	bool isInvalidateVote() { return value & 256 != 0; }
	void setInvalidateVote() { value = value & 256; }
	static AdministratorPermission invalidateVote() { return new AdministratorPermission(value: 256); }
	bool isTester() { return value & 512 != 0; }
	void setTester() { value = value & 512; }
	static AdministratorPermission tester() { return new AdministratorPermission(value: 512); }
	bool isAdminFiles() { return value & 1024 != 0; }
	void setAdminFiles() { value = value & 1024; }
	static AdministratorPermission adminFiles() { return new AdministratorPermission(value: 1024); }
	bool isSearchVoter() { return value & 2048 != 0; }
	void setSearchVoter() { value = value & 2048; }
	static AdministratorPermission searchVoter() { return new AdministratorPermission(value: 2048); }
	bool isChatAttendant() { return value & 4096 != 0; }
	void setChatAttendant() { value = value & 4096; }
	static AdministratorPermission chatAttendant() { return new AdministratorPermission(value: 4096); }
	bool isAdminMonitor() { return value & 8192 != 0; }
	void setAdminMonitor() { value = value & 8192; }
	static AdministratorPermission adminMonitor() { return new AdministratorPermission(value: 8192); }
	bool isOpenMonitor() { return value & 16384 != 0; }
	void setOpenMonitor() { value = value & 16384; }
	static AdministratorPermission openMonitor() { return new AdministratorPermission(value: 16384); }
	bool isAddDocumentVoter() { return value & 32768 != 0; }
	void setAddDocumentVoter() { value = value & 32768; }
	static AdministratorPermission addDocumentVoter() { return new AdministratorPermission(value: 32768); }
	bool isOpenResultMonitor() { return value & 65536 != 0; }
	void setOpenResultMonitor() { value = value & 65536; }
	static AdministratorPermission openResultMonitor() { return new AdministratorPermission(value: 65536); }
	bool isIpManager() { return value & 131072 != 0; }
	void setIpManager() { value = value & 131072; }
	static AdministratorPermission ipManager() { return new AdministratorPermission(value: 131072); }
}

// Enum type
class ChatRequestSupportBestReason {
	int value;
	ChatRequestSupportBestReason({this.value});
	void clear() { value = 0; }
	bool isNoConclusions() { return value & 0 != 0; }
	void setNoConclusions() { value = value & 0; }
	static ChatRequestSupportBestReason noConclusions() { return new ChatRequestSupportBestReason(value: 0); }
	bool isUserNotFound() { return value & 1 != 0; }
	void setUserNotFound() { value = value & 1; }
	static ChatRequestSupportBestReason userNotFound() { return new ChatRequestSupportBestReason(value: 1); }
	bool isEmailNotFound() { return value & 2 != 0; }
	void setEmailNotFound() { value = value & 2; }
	static ChatRequestSupportBestReason emailNotFound() { return new ChatRequestSupportBestReason(value: 2); }
	bool isPhoneNotFound() { return value & 4 != 0; }
	void setPhoneNotFound() { value = value & 4; }
	static ChatRequestSupportBestReason phoneNotFound() { return new ChatRequestSupportBestReason(value: 4); }
	bool isDocumentoNotFound() { return value & 8 != 0; }
	void setDocumentoNotFound() { value = value & 8; }
	static ChatRequestSupportBestReason documentoNotFound() { return new ChatRequestSupportBestReason(value: 8); }
	bool isNameNotFound() { return value & 16 != 0; }
	void setNameNotFound() { value = value & 16; }
	static ChatRequestSupportBestReason nameNotFound() { return new ChatRequestSupportBestReason(value: 16); }
	bool isDifferentUsers() { return value & 32 != 0; }
	void setDifferentUsers() { value = value & 32; }
	static ChatRequestSupportBestReason differentUsers() { return new ChatRequestSupportBestReason(value: 32); }
	bool isNonVoter() { return value & 64 != 0; }
	void setNonVoter() { value = value & 64; }
	static ChatRequestSupportBestReason nonVoter() { return new ChatRequestSupportBestReason(value: 64); }
	bool isAlreadyLogin() { return value & 128 != 0; }
	void setAlreadyLogin() { value = value & 128; }
	static ChatRequestSupportBestReason alreadyLogin() { return new ChatRequestSupportBestReason(value: 128); }
	bool isAlreadyVoteSome() { return value & 256 != 0; }
	void setAlreadyVoteSome() { value = value & 256; }
	static ChatRequestSupportBestReason alreadyVoteSome() { return new ChatRequestSupportBestReason(value: 256); }
	bool isAlreadyVoteAll() { return value & 512 != 0; }
	void setAlreadyVoteAll() { value = value & 512; }
	static ChatRequestSupportBestReason alreadyVoteAll() { return new ChatRequestSupportBestReason(value: 512); }
	bool isAllPoolsNotStartedYet() { return value & 1024 != 0; }
	void setAllPoolsNotStartedYet() { value = value & 1024; }
	static ChatRequestSupportBestReason allPoolsNotStartedYet() { return new ChatRequestSupportBestReason(value: 1024); }
	bool isSomePoolsNotStartedYet() { return value & 2048 != 0; }
	void setSomePoolsNotStartedYet() { value = value & 2048; }
	static ChatRequestSupportBestReason somePoolsNotStartedYet() { return new ChatRequestSupportBestReason(value: 2048); }
	bool isAllPoolsAlreadyFinish() { return value & 4096 != 0; }
	void setAllPoolsAlreadyFinish() { value = value & 4096; }
	static ChatRequestSupportBestReason allPoolsAlreadyFinish() { return new ChatRequestSupportBestReason(value: 4096); }
	bool isSomePoolsAlreadyFinish() { return value & 8192 != 0; }
	void setSomePoolsAlreadyFinish() { value = value & 8192; }
	static ChatRequestSupportBestReason somePoolsAlreadyFinish() { return new ChatRequestSupportBestReason(value: 8192); }
	bool isUserFound() { return value & 16384 != 0; }
	void setUserFound() { value = value & 16384; }
	static ChatRequestSupportBestReason userFound() { return new ChatRequestSupportBestReason(value: 16384); }
	bool isAlreadyAttendant() { return value & 32768 != 0; }
	void setAlreadyAttendant() { value = value & 32768; }
	static ChatRequestSupportBestReason alreadyAttendant() { return new ChatRequestSupportBestReason(value: 32768); }
	bool isInvalidToken() { return value & 65536 != 0; }
	void setInvalidToken() { value = value & 65536; }
	static ChatRequestSupportBestReason invalidToken() { return new ChatRequestSupportBestReason(value: 65536); }
}

// Enum type
class ChatUserType {
	int value;
	ChatUserType({this.value});
	void clear() { value = 0; }
	bool isUser() { return value & 0 != 0; }
	void setUser() { value = value & 0; }
	static ChatUserType user() { return new ChatUserType(value: 0); }
	bool isAttendant() { return value & 1 != 0; }
	void setAttendant() { value = value & 1; }
	static ChatUserType attendant() { return new ChatUserType(value: 1); }
	bool isSystem() { return value & 2 != 0; }
	void setSystem() { value = value & 2; }
	static ChatUserType system() { return new ChatUserType(value: 2); }
}

// Enum type
class CredentialType {
	int value;
	CredentialType({this.value});
	void clear() { value = 0; }
	bool isEmail() { return value & 0 != 0; }
	void setEmail() { value = value & 0; }
	static CredentialType email() { return new CredentialType(value: 0); }
	bool isPhone() { return value & 1 != 0; }
	void setPhone() { value = value & 1; }
	static CredentialType phone() { return new CredentialType(value: 1); }
	bool isDocument() { return value & 2 != 0; }
	void setDocument() { value = value & 2; }
	static CredentialType document() { return new CredentialType(value: 2); }
}

// Enum type
class EmailProviderType {
	int value;
	EmailProviderType({this.value});
	void clear() { value = 0; }
	bool isSMTP() { return value & 0 != 0; }
	void setSMTP() { value = value & 0; }
	static EmailProviderType sMTP() { return new EmailProviderType(value: 0); }
	bool isSendGrid() { return value & 1 != 0; }
	void setSendGrid() { value = value & 1; }
	static EmailProviderType sendGrid() { return new EmailProviderType(value: 1); }
	bool isSendInBlue() { return value & 2 != 0; }
	void setSendInBlue() { value = value & 2; }
	static EmailProviderType sendInBlue() { return new EmailProviderType(value: 2); }
}

// Enum type
class EventAction {
	int value;
	EventAction({this.value});
	void clear() { value = 0; }
	bool isGetChallenge() { return value & 0 != 0; }
	void setGetChallenge() { value = value & 0; }
	static EventAction getChallenge() { return new EventAction(value: 0); }
	bool isReadConfiguration() { return value & 1 != 0; }
	void setReadConfiguration() { value = value & 1; }
	static EventAction readConfiguration() { return new EventAction(value: 1); }
	bool isSaveConfiguration() { return value & 2 != 0; }
	void setSaveConfiguration() { value = value & 2; }
	static EventAction saveConfiguration() { return new EventAction(value: 2); }
	bool isImportVoters() { return value & 3 != 0; }
	void setImportVoters() { value = value & 3; }
	static EventAction importVoters() { return new EventAction(value: 3); }
	bool isMixVotes() { return value & 4 != 0; }
	void setMixVotes() { value = value & 4; }
	static EventAction mixVotes() { return new EventAction(value: 4); }
	bool isInitializePage() { return value & 5 != 0; }
	void setInitializePage() { value = value & 5; }
	static EventAction initializePage() { return new EventAction(value: 5); }
	bool isStartPasswordSession() { return value & 6 != 0; }
	void setStartPasswordSession() { value = value & 6; }
	static EventAction startPasswordSession() { return new EventAction(value: 6); }
	bool isChangePassword() { return value & 7 != 0; }
	void setChangePassword() { value = value & 7; }
	static EventAction changePassword() { return new EventAction(value: 7); }
	bool isEndSession() { return value & 8 != 0; }
	void setEndSession() { value = value & 8; }
	static EventAction endSession() { return new EventAction(value: 8); }
	bool isCastVotes() { return value & 9 != 0; }
	void setCastVotes() { value = value & 9; }
	static EventAction castVotes() { return new EventAction(value: 9); }
	bool isResetPasswordStart() { return value & 10 != 0; }
	void setResetPasswordStart() { value = value & 10; }
	static EventAction resetPasswordStart() { return new EventAction(value: 10); }
	bool isResetPasswordFinish() { return value & 11 != 0; }
	void setResetPasswordFinish() { value = value & 11; }
	static EventAction resetPasswordFinish() { return new EventAction(value: 11); }
	bool isTooglePool() { return value & 12 != 0; }
	void setTooglePool() { value = value & 12; }
	static EventAction tooglePool() { return new EventAction(value: 12); }
	bool isToogleVoterPool() { return value & 13 != 0; }
	void setToogleVoterPool() { value = value & 13; }
	static EventAction toogleVoterPool() { return new EventAction(value: 13); }
	bool isGetAllVoters() { return value & 14 != 0; }
	void setGetAllVoters() { value = value & 14; }
	static EventAction getAllVoters() { return new EventAction(value: 14); }
	bool isReceiptVerify() { return value & 15 != 0; }
	void setReceiptVerify() { value = value & 15; }
	static EventAction receiptVerify() { return new EventAction(value: 15); }
	bool isAddVoter() { return value & 16 != 0; }
	void setAddVoter() { value = value & 16; }
	static EventAction addVoter() { return new EventAction(value: 16); }
	bool isToogleCredential() { return value & 17 != 0; }
	void setToogleCredential() { value = value & 17; }
	static EventAction toogleCredential() { return new EventAction(value: 17); }
	bool isAddCredential() { return value & 18 != 0; }
	void setAddCredential() { value = value & 18; }
	static EventAction addCredential() { return new EventAction(value: 18); }
	bool isSendTokenByCredential() { return value & 19 != 0; }
	void setSendTokenByCredential() { value = value & 19; }
	static EventAction sendTokenByCredential() { return new EventAction(value: 19); }
	bool isVoteMonitor() { return value & 20 != 0; }
	void setVoteMonitor() { value = value & 20; }
	static EventAction voteMonitor() { return new EventAction(value: 20); }
	bool isResetPasswordByLink() { return value & 21 != 0; }
	void setResetPasswordByLink() { value = value & 21; }
	static EventAction resetPasswordByLink() { return new EventAction(value: 21); }
	bool isGetUserEvent() { return value & 22 != 0; }
	void setGetUserEvent() { value = value & 22; }
	static EventAction getUserEvent() { return new EventAction(value: 22); }
	bool isDownloadEvents() { return value & 23 != 0; }
	void setDownloadEvents() { value = value & 23; }
	static EventAction downloadEvents() { return new EventAction(value: 23); }
	bool isGetActiveUsers() { return value & 24 != 0; }
	void setGetActiveUsers() { value = value & 24; }
	static EventAction getActiveUsers() { return new EventAction(value: 24); }
	bool isGetAdminEvents() { return value & 25 != 0; }
	void setGetAdminEvents() { value = value & 25; }
	static EventAction getAdminEvents() { return new EventAction(value: 25); }
	bool isGetAdminEvent() { return value & 26 != 0; }
	void setGetAdminEvent() { value = value & 26; }
	static EventAction getAdminEvent() { return new EventAction(value: 26); }
	bool isEventMonitor() { return value & 27 != 0; }
	void setEventMonitor() { value = value & 27; }
	static EventAction eventMonitor() { return new EventAction(value: 27); }
	bool isUserAgentMonitor() { return value & 28 != 0; }
	void setUserAgentMonitor() { value = value & 28; }
	static EventAction userAgentMonitor() { return new EventAction(value: 28); }
	bool isGetUserAgentEvent() { return value & 29 != 0; }
	void setGetUserAgentEvent() { value = value & 29; }
	static EventAction getUserAgentEvent() { return new EventAction(value: 29); }
	bool isChatAddConversationPublic() { return value & 30 != 0; }
	void setChatAddConversationPublic() { value = value & 30; }
	static EventAction chatAddConversationPublic() { return new EventAction(value: 30); }
	bool isChatAddConversationAttendant() { return value & 31 != 0; }
	void setChatAddConversationAttendant() { value = value & 31; }
	static EventAction chatAddConversationAttendant() { return new EventAction(value: 31); }
	bool isChatSendMessageToAttendant() { return value & 32 != 0; }
	void setChatSendMessageToAttendant() { value = value & 32; }
	static EventAction chatSendMessageToAttendant() { return new EventAction(value: 32); }
	bool isChatSendMessageToUser() { return value & 33 != 0; }
	void setChatSendMessageToUser() { value = value & 33; }
	static EventAction chatSendMessageToUser() { return new EventAction(value: 33); }
	bool isChatReadMessage() { return value & 34 != 0; }
	void setChatReadMessage() { value = value & 34; }
	static EventAction chatReadMessage() { return new EventAction(value: 34); }
	bool isChatFinishConversation() { return value & 35 != 0; }
	void setChatFinishConversation() { value = value & 35; }
	static EventAction chatFinishConversation() { return new EventAction(value: 35); }
	bool isChatAddReasonMessage() { return value & 36 != 0; }
	void setChatAddReasonMessage() { value = value & 36; }
	static EventAction chatAddReasonMessage() { return new EventAction(value: 36); }
	bool isChatReadConversation() { return value & 37 != 0; }
	void setChatReadConversation() { value = value & 37; }
	static EventAction chatReadConversation() { return new EventAction(value: 37); }
	bool isGetVoter() { return value & 38 != 0; }
	void setGetVoter() { value = value & 38; }
	static EventAction getVoter() { return new EventAction(value: 38); }
	bool isChatCreateAttendant() { return value & 39 != 0; }
	void setChatCreateAttendant() { value = value & 39; }
	static EventAction chatCreateAttendant() { return new EventAction(value: 39); }
	bool isChatAssociateVoter() { return value & 40 != 0; }
	void setChatAssociateVoter() { value = value & 40; }
	static EventAction chatAssociateVoter() { return new EventAction(value: 40); }
	bool isInvalidateVote() { return value & 41 != 0; }
	void setInvalidateVote() { value = value & 41; }
	static EventAction invalidateVote() { return new EventAction(value: 41); }
	bool isReadFaceToFaceBallotBoxes() { return value & 42 != 0; }
	void setReadFaceToFaceBallotBoxes() { value = value & 42; }
	static EventAction readFaceToFaceBallotBoxes() { return new EventAction(value: 42); }
	bool isGenerateFaceToFaceBallotBoxCode() { return value & 43 != 0; }
	void setGenerateFaceToFaceBallotBoxCode() { value = value & 43; }
	static EventAction generateFaceToFaceBallotBoxCode() { return new EventAction(value: 43); }
	bool isLoginFaceToFaceBallotBox() { return value & 44 != 0; }
	void setLoginFaceToFaceBallotBox() { value = value & 44; }
	static EventAction loginFaceToFaceBallotBox() { return new EventAction(value: 44); }
	bool isSendVoterFaceToFaceBallotBox() { return value & 45 != 0; }
	void setSendVoterFaceToFaceBallotBox() { value = value & 45; }
	static EventAction sendVoterFaceToFaceBallotBox() { return new EventAction(value: 45); }
	bool isImportPositiveIdentificationNames() { return value & 46 != 0; }
	void setImportPositiveIdentificationNames() { value = value & 46; }
	static EventAction importPositiveIdentificationNames() { return new EventAction(value: 46); }
	bool isGetUserContacts() { return value & 47 != 0; }
	void setGetUserContacts() { value = value & 47; }
	static EventAction getUserContacts() { return new EventAction(value: 47); }
	bool isGetPositiveIdentificationChallenge() { return value & 48 != 0; }
	void setGetPositiveIdentificationChallenge() { value = value & 48; }
	static EventAction getPositiveIdentificationChallenge() { return new EventAction(value: 48); }
	bool isAnswerPositiveIdentificationChallenge() { return value & 49 != 0; }
	void setAnswerPositiveIdentificationChallenge() { value = value & 49; }
	static EventAction answerPositiveIdentificationChallenge() { return new EventAction(value: 49); }
	bool isAddContactByPublic() { return value & 50 != 0; }
	void setAddContactByPublic() { value = value & 50; }
	static EventAction addContactByPublic() { return new EventAction(value: 50); }
	bool isListSharedGroups() { return value & 51 != 0; }
	void setListSharedGroups() { value = value & 51; }
	static EventAction listSharedGroups() { return new EventAction(value: 51); }
	bool isRegisterPIN() { return value & 52 != 0; }
	void setRegisterPIN() { value = value & 52; }
	static EventAction registerPIN() { return new EventAction(value: 52); }
	bool isListRegisteredPINs() { return value & 53 != 0; }
	void setListRegisteredPINs() { value = value & 53; }
	static EventAction listRegisteredPINs() { return new EventAction(value: 53); }
	bool isRenderTemplateUpload() { return value & 54 != 0; }
	void setRenderTemplateUpload() { value = value & 54; }
	static EventAction renderTemplateUpload() { return new EventAction(value: 54); }
	bool isSearchVoterByDocument() { return value & 55 != 0; }
	void setSearchVoterByDocument() { value = value & 55; }
	static EventAction searchVoterByDocument() { return new EventAction(value: 55); }
	bool isForcePoolStart() { return value & 56 != 0; }
	void setForcePoolStart() { value = value & 56; }
	static EventAction forcePoolStart() { return new EventAction(value: 56); }
	bool isGetPasswordForCertificate() { return value & 57 != 0; }
	void setGetPasswordForCertificate() { value = value & 57; }
	static EventAction getPasswordForCertificate() { return new EventAction(value: 57); }
	bool isAddIpToBlackList() { return value & 58 != 0; }
	void setAddIpToBlackList() { value = value & 58; }
	static EventAction addIpToBlackList() { return new EventAction(value: 58); }
	bool isRemoveIpFromBlackList() { return value & 59 != 0; }
	void setRemoveIpFromBlackList() { value = value & 59; }
	static EventAction removeIpFromBlackList() { return new EventAction(value: 59); }
	bool isAddIpToWhiteList() { return value & 60 != 0; }
	void setAddIpToWhiteList() { value = value & 60; }
	static EventAction addIpToWhiteList() { return new EventAction(value: 60); }
	bool isRemoveIpFromWhiteList() { return value & 61 != 0; }
	void setRemoveIpFromWhiteList() { value = value & 61; }
	static EventAction removeIpFromWhiteList() { return new EventAction(value: 61); }
	bool isListManagedIps() { return value & 62 != 0; }
	void setListManagedIps() { value = value & 62; }
	static EventAction listManagedIps() { return new EventAction(value: 62); }
	bool isGetVoterStatus() { return value & 63 != 0; }
	void setGetVoterStatus() { value = value & 63; }
	static EventAction getVoterStatus() { return new EventAction(value: 63); }
	bool isGetConfiguration() { return value & 64 != 0; }
	void setGetConfiguration() { value = value & 64; }
	static EventAction getConfiguration() { return new EventAction(value: 64); }
	bool isReleaseIP() { return value & 65 != 0; }
	void setReleaseIP() { value = value & 65; }
	static EventAction releaseIP() { return new EventAction(value: 65); }
	bool isGetIPEvent() { return value & 66 != 0; }
	void setGetIPEvent() { value = value & 66; }
	static EventAction getIPEvent() { return new EventAction(value: 66); }
}

// Enum type
class IpManageableType {
	int value;
	IpManageableType({this.value});
	void clear() { value = 0; }
	bool isUnknown() { return value & 0 != 0; }
	void setUnknown() { value = value & 0; }
	static IpManageableType unknown() { return new IpManageableType(value: 0); }
	bool isBlackList() { return value & 1 != 0; }
	void setBlackList() { value = value & 1; }
	static IpManageableType blackList() { return new IpManageableType(value: 1); }
	bool isWhiteList() { return value & 2 != 0; }
	void setWhiteList() { value = value & 2; }
	static IpManageableType whiteList() { return new IpManageableType(value: 2); }
}

// Enum type
class PositiveIdentificationQuestionType {
	int value;
	PositiveIdentificationQuestionType({this.value});
	void clear() { value = 0; }
	bool isList() { return value & 1 != 0; }
	void setList() { value = value & 1; }
	static PositiveIdentificationQuestionType list() { return new PositiveIdentificationQuestionType(value: 1); }
	bool isDiscursive() { return value & 2 != 0; }
	void setDiscursive() { value = value & 2; }
	static PositiveIdentificationQuestionType discursive() { return new PositiveIdentificationQuestionType(value: 2); }
}

// Enum type
class RemoteIpAccessType {
	int value;
	RemoteIpAccessType({this.value});
	void clear() { value = 0; }
	bool isUnauthenticated() { return value & 0 != 0; }
	void setUnauthenticated() { value = value & 0; }
	static RemoteIpAccessType unauthenticated() { return new RemoteIpAccessType(value: 0); }
	bool isUser() { return value & 1 != 0; }
	void setUser() { value = value & 1; }
	static RemoteIpAccessType user() { return new RemoteIpAccessType(value: 1); }
	bool isAdmin() { return value & 2 != 0; }
	void setAdmin() { value = value & 2; }
	static RemoteIpAccessType admin() { return new RemoteIpAccessType(value: 2); }
}

// Enum type
class SMSProviderType {
	int value;
	SMSProviderType({this.value});
	void clear() { value = 0; }
	bool isNexmo() { return value & 0 != 0; }
	void setNexmo() { value = value & 0; }
	static SMSProviderType nexmo() { return new SMSProviderType(value: 0); }
	bool isZenvia() { return value & 1 != 0; }
	void setZenvia() { value = value & 1; }
	static SMSProviderType zenvia() { return new SMSProviderType(value: 1); }
	bool isTWW() { return value & 2 != 0; }
	void setTWW() { value = value & 2; }
	static SMSProviderType tWW() { return new SMSProviderType(value: 2); }
}

// Enum type
class VoteVerify {
	int value;
	VoteVerify({this.value});
	void clear() { value = 0; }
	bool isOk() { return value & 0 != 0; }
	void setOk() { value = value & 0; }
	static VoteVerify ok() { return new VoteVerify(value: 0); }
	bool isReceiptNotFound() { return value & 1 != 0; }
	void setReceiptNotFound() { value = value & 1; }
	static VoteVerify receiptNotFound() { return new VoteVerify(value: 1); }
	bool isInvalidCredential() { return value & 2 != 0; }
	void setInvalidCredential() { value = value & 2; }
	static VoteVerify invalidCredential() { return new VoteVerify(value: 2); }
	bool isAlreadyRegistered() { return value & 3 != 0; }
	void setAlreadyRegistered() { value = value & 3; }
	static VoteVerify alreadyRegistered() { return new VoteVerify(value: 3); }
	bool isInvalidVoteSignature() { return value & 4 != 0; }
	void setInvalidVoteSignature() { value = value & 4; }
	static VoteVerify invalidVoteSignature() { return new VoteVerify(value: 4); }
	bool isInvalidReceiptSignature() { return value & 5 != 0; }
	void setInvalidReceiptSignature() { value = value & 5; }
	static VoteVerify invalidReceiptSignature() { return new VoteVerify(value: 5); }
	bool isException() { return value & 6 != 0; }
	void setException() { value = value & 6; }
	static VoteVerify exception() { return new VoteVerify(value: 6); }
	bool isRemovedByOperator() { return value & 7 != 0; }
	void setRemovedByOperator() { value = value & 7; }
	static VoteVerify removedByOperator() { return new VoteVerify(value: 7); }
}

class ActiveUsersRequestModel extends PrivateAccessRequestModel {

	ActiveUsersRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ActiveUsersRequestModel create(Map<String, dynamic> json) {
		var ret = new ActiveUsersRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ActiveUsersResponseModel extends PrivateAccessResponseModel {
	List<SessionModel> actives;

	ActiveUsersResponseModel({ List<SessionModel> actives, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.actives = actives;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.actives != null) json['actives'] = this.actives.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['actives'] != null) this.actives = new List<Map<String, dynamic>>.from(json['actives']).map((l) => SessionModel.create(l)).toList();
	}

	static ActiveUsersResponseModel create(Map<String, dynamic> json) {
		var ret = new ActiveUsersResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddContactByPublicRequestModel extends RequestTokenRequestModel {
	int userId;
	String contact;
	CredentialType contactType;
	int challengeId;

	AddContactByPublicRequestModel({ int userId, String contact, CredentialType contactType, int challengeId, int organizationId }) : super(organizationId: organizationId){ 
		this.userId = userId;
		this.contact = contact;
		this.contactType = contactType;
		this.challengeId = challengeId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		json['challengeId'] = this.challengeId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
		this.challengeId = json['challengeId'];
	}

	static AddContactByPublicRequestModel create(Map<String, dynamic> json) {
		var ret = new AddContactByPublicRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddContactByPublicResponseModel extends TokenByLinkResponseModel {

	AddContactByPublicResponseModel({ String pkcs12, int iterationCount, String pinSalt, int tokenId, String tokenDoubleHash, String link,  }) : super(pkcs12: pkcs12, iterationCount: iterationCount, pinSalt: pinSalt, tokenId: tokenId, tokenDoubleHash: tokenDoubleHash, link: link, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static AddContactByPublicResponseModel create(Map<String, dynamic> json) {
		var ret = new AddContactByPublicResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddCredentialRequestModel extends PrivateAccessRequestModel {
	int userId;
	String contact;
	String note;
	CredentialType contactType;

	AddCredentialRequestModel({ int userId, String contact, String note, CredentialType contactType, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.userId = userId;
		this.contact = contact;
		this.note = note;
		this.contactType = contactType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		json['contact'] = this.contact;
		json['note'] = this.note;
		json['contactType'] = this.contactType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
		this.contact = json['contact'];
		this.note = json['note'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
	}

	static AddCredentialRequestModel create(Map<String, dynamic> json) {
		var ret = new AddCredentialRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddCredentialResponseModel extends PrivateAccessResponseModel {
	int credentialId;
	String providerResponse;

	AddCredentialResponseModel({ int credentialId, String providerResponse, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.credentialId = credentialId;
		this.providerResponse = providerResponse;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['credentialId'] = this.credentialId;
		json['providerResponse'] = this.providerResponse;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.credentialId = json['credentialId'];
		this.providerResponse = json['providerResponse'];
	}

	static AddCredentialResponseModel create(Map<String, dynamic> json) {
		var ret = new AddCredentialResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddIpToBlackListRequestModel extends PrivateAccessRequestModel {
	String remoteIpAddress;

	AddIpToBlackListRequestModel({ String remoteIpAddress, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.remoteIpAddress = remoteIpAddress;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['remoteIpAddress'] = this.remoteIpAddress;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.remoteIpAddress = json['remoteIpAddress'];
	}

	static AddIpToBlackListRequestModel create(Map<String, dynamic> json) {
		var ret = new AddIpToBlackListRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddIpToBlackListResponseModel extends PrivateAccessResponseModel {

	AddIpToBlackListResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static AddIpToBlackListResponseModel create(Map<String, dynamic> json) {
		var ret = new AddIpToBlackListResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddIpToWhiteListRequestModel extends PrivateAccessRequestModel {
	String remoteIpAddress;

	AddIpToWhiteListRequestModel({ String remoteIpAddress, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.remoteIpAddress = remoteIpAddress;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['remoteIpAddress'] = this.remoteIpAddress;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.remoteIpAddress = json['remoteIpAddress'];
	}

	static AddIpToWhiteListRequestModel create(Map<String, dynamic> json) {
		var ret = new AddIpToWhiteListRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddIpToWhiteListResponseModel extends PrivateAccessResponseModel {

	AddIpToWhiteListResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static AddIpToWhiteListResponseModel create(Map<String, dynamic> json) {
		var ret = new AddIpToWhiteListResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddVoterRequestModel extends PrivateAccessRequestModel {
	String name;

	AddVoterRequestModel({ String name, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.name = name;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['name'] = this.name;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.name = json['name'];
	}

	static AddVoterRequestModel create(Map<String, dynamic> json) {
		var ret = new AddVoterRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AddVoterResponseModel extends PrivateAccessResponseModel {
	int userId;

	AddVoterResponseModel({ int userId, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.userId = userId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
	}

	static AddVoterResponseModel create(Map<String, dynamic> json) {
		var ret = new AddVoterResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AdminEventModel {
	int qtd;
	EventAction eventAction;

	AdminEventModel({ int qtd, EventAction eventAction }){ 
		this.qtd = qtd;
		this.eventAction = eventAction;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['qtd'] = this.qtd;
		json['eventAction'] = this.eventAction.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.qtd = json['qtd'];
		this.eventAction = new EventAction(value: int.parse(json['eventAction'].toString()));
	}

	static AdminEventModel create(Map<String, dynamic> json) {
		var ret = new AdminEventModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AdminEventsRequestModel extends PrivateAccessRequestModel {

	AdminEventsRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static AdminEventsRequestModel create(Map<String, dynamic> json) {
		var ret = new AdminEventsRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AdminEventsResponseModel extends PrivateAccessResponseModel {
	List<AdminModel> admins;

	AdminEventsResponseModel({ List<AdminModel> admins, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.admins = admins;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.admins != null) json['admins'] = this.admins.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['admins'] != null) this.admins = new List<Map<String, dynamic>>.from(json['admins']).map((l) => AdminModel.create(l)).toList();
	}

	static AdminEventsResponseModel create(Map<String, dynamic> json) {
		var ret = new AdminEventsResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AdministratorModel {
	int id;
	int organizationId;

	AdministratorModel({ int id, int organizationId }){ 
		this.id = id;
		this.organizationId = organizationId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['organizationId'] = this.organizationId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.organizationId = json['organizationId'];
	}

	static AdministratorModel create(Map<String, dynamic> json) {
		var ret = new AdministratorModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AdminModel {
	BeeUserModel user;
	List<AdminEventModel> events;

	AdminModel({ BeeUserModel user, List<AdminEventModel> events }){ 
		this.user = user;
		this.events = events;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['user'] = this.user.toJson();
		if (this.events != null) json['events'] = this.events.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.user = BeeUserModel.create(json['user']);
		if (json['events'] != null) this.events = new List<Map<String, dynamic>>.from(json['events']).map((l) => AdminEventModel.create(l)).toList();
	}

	static AdminModel create(Map<String, dynamic> json) {
		var ret = new AdminModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AllMeetingResults {
	MeetingResult meeting;

	AllMeetingResults({ MeetingResult meeting }){ 
		this.meeting = meeting;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['meeting'] = this.meeting.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.meeting = MeetingResult.create(json['meeting']);
	}

	static AllMeetingResults create(Map<String, dynamic> json) {
		var ret = new AllMeetingResults();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AnswerPositiveIdentificationChallengeQuestionModel extends PublicAccessRequestModel {
	int questionId;
	String answerString;
	int answerOptionId;

	AnswerPositiveIdentificationChallengeQuestionModel({ int questionId, String answerString, int answerOptionId, int organizationId }) : super(organizationId: organizationId){ 
		this.questionId = questionId;
		this.answerString = answerString;
		this.answerOptionId = answerOptionId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['questionId'] = this.questionId;
		json['answerString'] = this.answerString;
		json['answerOptionId'] = this.answerOptionId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.questionId = json['questionId'];
		this.answerString = json['answerString'];
		this.answerOptionId = json['answerOptionId'];
	}

	static AnswerPositiveIdentificationChallengeQuestionModel create(Map<String, dynamic> json) {
		var ret = new AnswerPositiveIdentificationChallengeQuestionModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AnswerPositiveIdentificationChallengeRequestModel extends PublicAccessRequestModel {
	int challengeId;
	List<AnswerPositiveIdentificationChallengeQuestionModel> answers;

	AnswerPositiveIdentificationChallengeRequestModel({ int challengeId, List<AnswerPositiveIdentificationChallengeQuestionModel> answers, int organizationId }) : super(organizationId: organizationId){ 
		this.challengeId = challengeId;
		this.answers = answers;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['challengeId'] = this.challengeId;
		if (this.answers != null) json['answers'] = this.answers.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.challengeId = json['challengeId'];
		if (json['answers'] != null) this.answers = new List<Map<String, dynamic>>.from(json['answers']).map((l) => AnswerPositiveIdentificationChallengeQuestionModel.create(l)).toList();
	}

	static AnswerPositiveIdentificationChallengeRequestModel create(Map<String, dynamic> json) {
		var ret = new AnswerPositiveIdentificationChallengeRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class AnswerPositiveIdentificationChallengeResponseModel extends PublicAccessResponseModel {
	int userId;
	bool correct;
	bool incorrect;

	AnswerPositiveIdentificationChallengeResponseModel({ int userId, bool correct, bool incorrect,  }) : super(){ 
		this.userId = userId;
		this.correct = correct;
		this.incorrect = incorrect;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		json['correct'] = this.correct;
		json['incorrect'] = this.incorrect;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
		this.correct = json['correct'];
		this.incorrect = json['incorrect'];
	}

	static AnswerPositiveIdentificationChallengeResponseModel create(Map<String, dynamic> json) {
		var ret = new AnswerPositiveIdentificationChallengeResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class BallotBoxModel {
	int id;
	String name;
	DateTime started;
	KeyPairInfoModel publicKey;
	List<EventModel> events;

	BallotBoxModel({ int id, String name, DateTime started, KeyPairInfoModel publicKey, List<EventModel> events }){ 
		this.id = id;
		this.name = name;
		this.started = started;
		this.publicKey = publicKey;
		this.events = events;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['name'] = this.name;
		if (this.started != null) json['started'] = CommonConversion.date2String(this.started);
		json['publicKey'] = this.publicKey.toJson();
		if (this.events != null) json['events'] = this.events.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.name = json['name'];
		this.started = CommonConversion.string2Date(json['started']);
		this.publicKey = KeyPairInfoModel.create(json['publicKey']);
		if (json['events'] != null) this.events = new List<Map<String, dynamic>>.from(json['events']).map((l) => EventModel.create(l)).toList();
	}

	static BallotBoxModel create(Map<String, dynamic> json) {
		var ret = new BallotBoxModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class BallotBoxResult {
	int ballotBoxId;
	List<PoolResult> results;

	BallotBoxResult({ int ballotBoxId, List<PoolResult> results }){ 
		this.ballotBoxId = ballotBoxId;
		this.results = results;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['ballotBoxId'] = this.ballotBoxId;
		if (this.results != null) json['results'] = this.results.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.ballotBoxId = json['ballotBoxId'];
		if (json['results'] != null) this.results = new List<Map<String, dynamic>>.from(json['results']).map((l) => PoolResult.create(l)).toList();
	}

	static BallotBoxResult create(Map<String, dynamic> json) {
		var ret = new BallotBoxResult();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class BeeUserModel {
	int id;
	String name;
	List<AdministratorModel> administrators;
	List<VoterPoolModel> pools;
	List<PVoterCredentialModel> credentials;
	List<DataValueModel> dataValues;

	BeeUserModel({ int id, String name, List<AdministratorModel> administrators, List<VoterPoolModel> pools, List<PVoterCredentialModel> credentials, List<DataValueModel> dataValues }){ 
		this.id = id;
		this.name = name;
		this.administrators = administrators;
		this.pools = pools;
		this.credentials = credentials;
		this.dataValues = dataValues;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['name'] = this.name;
		if (this.administrators != null) json['administrators'] = this.administrators.map((e) => e.toJson()).toList();
		if (this.pools != null) json['pools'] = this.pools.map((e) => e.toJson()).toList();
		if (this.credentials != null) json['credentials'] = this.credentials.map((e) => e.toJson()).toList();
		if (this.dataValues != null) json['dataValues'] = this.dataValues.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.name = json['name'];
		if (json['administrators'] != null) this.administrators = new List<Map<String, dynamic>>.from(json['administrators']).map((l) => AdministratorModel.create(l)).toList();
		if (json['pools'] != null) this.pools = new List<Map<String, dynamic>>.from(json['pools']).map((l) => VoterPoolModel.create(l)).toList();
		if (json['credentials'] != null) this.credentials = new List<Map<String, dynamic>>.from(json['credentials']).map((l) => PVoterCredentialModel.create(l)).toList();
		if (json['dataValues'] != null) this.dataValues = new List<Map<String, dynamic>>.from(json['dataValues']).map((l) => DataValueModel.create(l)).toList();
	}

	static BeeUserModel create(Map<String, dynamic> json) {
		var ret = new BeeUserModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class CastVotesRequestModel extends PrivateAccessRequestModel {
	int voterId;
	List<VoteModel> votes;

	CastVotesRequestModel({ int voterId, List<VoteModel> votes, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.voterId = voterId;
		this.votes = votes;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['voterId'] = this.voterId;
		if (this.votes != null) json['votes'] = this.votes.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.voterId = json['voterId'];
		if (json['votes'] != null) this.votes = new List<Map<String, dynamic>>.from(json['votes']).map((l) => VoteModel.create(l)).toList();
	}

	static CastVotesRequestModel create(Map<String, dynamic> json) {
		var ret = new CastVotesRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class CastVotesResponseModel extends PrivateAccessResponseModel {
	String remoteIpAddress;
	List<VoteModel> receiptResponses;

	CastVotesResponseModel({ String remoteIpAddress, List<VoteModel> receiptResponses, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.remoteIpAddress = remoteIpAddress;
		this.receiptResponses = receiptResponses;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['remoteIpAddress'] = this.remoteIpAddress;
		if (this.receiptResponses != null) json['receiptResponses'] = this.receiptResponses.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.remoteIpAddress = json['remoteIpAddress'];
		if (json['receiptResponses'] != null) this.receiptResponses = new List<Map<String, dynamic>>.from(json['receiptResponses']).map((l) => VoteModel.create(l)).toList();
	}

	static CastVotesResponseModel create(Map<String, dynamic> json) {
		var ret = new CastVotesResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChallengeModel {
	int id;
	String value;

	ChallengeModel({ int id, String value }){ 
		this.id = id;
		this.value = value;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['value'] = this.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.value = json['value'];
	}

	static ChallengeModel create(Map<String, dynamic> json) {
		var ret = new ChallengeModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChangePasswordRequestModel extends ReadUserRequestModel {
	String hashCurrentPw;
	String hashNewPw;
	String pkcs12;
	int iterationCount;
	String pinSalt;

	ChangePasswordRequestModel({ String hashCurrentPw, String hashNewPw, String pkcs12, int iterationCount, String pinSalt, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.hashCurrentPw = hashCurrentPw;
		this.hashNewPw = hashNewPw;
		this.pkcs12 = pkcs12;
		this.iterationCount = iterationCount;
		this.pinSalt = pinSalt;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['hashCurrentPw'] = this.hashCurrentPw;
		json['hashNewPw'] = this.hashNewPw;
		json['pkcs12'] = this.pkcs12;
		json['iterationCount'] = this.iterationCount;
		json['pinSalt'] = this.pinSalt;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.hashCurrentPw = json['hashCurrentPw'];
		this.hashNewPw = json['hashNewPw'];
		this.pkcs12 = json['pkcs12'];
		this.iterationCount = json['iterationCount'];
		this.pinSalt = json['pinSalt'];
	}

	static ChangePasswordRequestModel create(Map<String, dynamic> json) {
		var ret = new ChangePasswordRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChangePasswordResponseModel extends ReadUserResponseModel {

	ChangePasswordResponseModel({ BeeUserModel user, int challengeId, String challenge,  }) : super(user: user, challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChangePasswordResponseModel create(Map<String, dynamic> json) {
		var ret = new ChangePasswordResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatAddReasonMessageRequestModel extends ChatSendMessageRequestModel {

	ChatAddReasonMessageRequestModel({ int conversationId, int chatUserId, String message, int organizationId }) : super(conversationId: conversationId, chatUserId: chatUserId, message: message, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatAddReasonMessageRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatAddReasonMessageRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatAddReasonMessageResponseModel extends ChatSendMessageResponseModel {

	ChatAddReasonMessageResponseModel({ int messageId,  }) : super(messageId: messageId, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatAddReasonMessageResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatAddReasonMessageResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatAssociateVoterRequestModel extends PrivateAccessRequestModel {
	int conversationId;
	int voterId;

	ChatAssociateVoterRequestModel({ int conversationId, int voterId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.conversationId = conversationId;
		this.voterId = voterId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['conversationId'] = this.conversationId;
		json['voterId'] = this.voterId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.conversationId = json['conversationId'];
		this.voterId = json['voterId'];
	}

	static ChatAssociateVoterRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatAssociateVoterRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatAssociateVoterResponseModel extends PrivateAccessResponseModel {

	ChatAssociateVoterResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatAssociateVoterResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatAssociateVoterResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatConversationModel {
	int id;
	DateTime start;
	DateTime finish;
	ChatRequestSupportBestReason bestReason;
	ChatUserModel requester;
	ChatUserModel attendant;
	List<ChatMessageModel> messages;

	ChatConversationModel({ int id, DateTime start, DateTime finish, ChatRequestSupportBestReason bestReason, ChatUserModel requester, ChatUserModel attendant, List<ChatMessageModel> messages }){ 
		this.id = id;
		this.start = start;
		this.finish = finish;
		this.bestReason = bestReason;
		this.requester = requester;
		this.attendant = attendant;
		this.messages = messages;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.start != null) json['start'] = CommonConversion.date2String(this.start);
		if (this.finish != null) json['finish'] = CommonConversion.date2String(this.finish);
		json['bestReason'] = this.bestReason.value;
		json['requester'] = this.requester.toJson();
		json['attendant'] = this.attendant.toJson();
		if (this.messages != null) json['messages'] = this.messages.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.start = CommonConversion.string2Date(json['start']);
		this.finish = CommonConversion.string2Date(json['finish']);
		this.bestReason = new ChatRequestSupportBestReason(value: int.parse(json['bestReason'].toString()));
		this.requester = ChatUserModel.create(json['requester']);
		this.attendant = ChatUserModel.create(json['attendant']);
		if (json['messages'] != null) this.messages = new List<Map<String, dynamic>>.from(json['messages']).map((l) => ChatMessageModel.create(l)).toList();
	}

	static ChatConversationModel create(Map<String, dynamic> json) {
		var ret = new ChatConversationModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatCreateAttendantRequestModel extends PrivateAccessRequestModel {

	ChatCreateAttendantRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatCreateAttendantRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatCreateAttendantRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatCreateAttendantResponseModel extends PrivateAccessResponseModel {
	ChatUserModel user;

	ChatCreateAttendantResponseModel({ ChatUserModel user, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.user = user;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['user'] = this.user.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.user = ChatUserModel.create(json['user']);
	}

	static ChatCreateAttendantResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatCreateAttendantResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatFinishConversationRequestModel extends PublicAccessRequestModel {
	int conversationId;

	ChatFinishConversationRequestModel({ int conversationId, int organizationId }) : super(organizationId: organizationId){ 
		this.conversationId = conversationId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['conversationId'] = this.conversationId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.conversationId = json['conversationId'];
	}

	static ChatFinishConversationRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatFinishConversationRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatFinishConversationResponseModel extends PublicAccessResponseModel {

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatFinishConversationResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatFinishConversationResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatMessageModel {
	int id;
	DateTime dateTime;
	String message;
	ChatUserModel from;

	ChatMessageModel({ int id, DateTime dateTime, String message, ChatUserModel from }){ 
		this.id = id;
		this.dateTime = dateTime;
		this.message = message;
		this.from = from;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.dateTime != null) json['dateTime'] = CommonConversion.date2String(this.dateTime);
		json['message'] = this.message;
		json['from'] = this.from.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.dateTime = CommonConversion.string2Date(json['dateTime']);
		this.message = json['message'];
		this.from = ChatUserModel.create(json['from']);
	}

	static ChatMessageModel create(Map<String, dynamic> json) {
		var ret = new ChatMessageModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatReadConversationRequestModel extends PublicAccessRequestModel {
	int conversationId;

	ChatReadConversationRequestModel({ int conversationId, int organizationId }) : super(organizationId: organizationId){ 
		this.conversationId = conversationId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['conversationId'] = this.conversationId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.conversationId = json['conversationId'];
	}

	static ChatReadConversationRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatReadConversationRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatReadConversationResponseModel extends PublicAccessResponseModel {
	ChatConversationModel conversation;

	ChatReadConversationResponseModel({ ChatConversationModel conversation,  }) : super(){ 
		this.conversation = conversation;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['conversation'] = this.conversation.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.conversation = ChatConversationModel.create(json['conversation']);
	}

	static ChatReadConversationResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatReadConversationResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatReadConversationsRequestModel extends PrivateAccessRequestModel {

	ChatReadConversationsRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatReadConversationsRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatReadConversationsRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatReadConversationsResponseModel extends PrivateAccessResponseModel {
	List<ChatConversationModel> conversations;

	ChatReadConversationsResponseModel({ List<ChatConversationModel> conversations, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.conversations = conversations;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.conversations != null) json['conversations'] = this.conversations.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['conversations'] != null) this.conversations = new List<Map<String, dynamic>>.from(json['conversations']).map((l) => ChatConversationModel.create(l)).toList();
	}

	static ChatReadConversationsResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatReadConversationsResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatReadMessageRequestModel extends PublicAccessRequestModel {
	int messageId;

	ChatReadMessageRequestModel({ int messageId, int organizationId }) : super(organizationId: organizationId){ 
		this.messageId = messageId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['messageId'] = this.messageId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.messageId = json['messageId'];
	}

	static ChatReadMessageRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatReadMessageRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatReadMessageResponseModel extends PublicAccessResponseModel {
	ChatMessageModel message;

	ChatReadMessageResponseModel({ ChatMessageModel message,  }) : super(){ 
		this.message = message;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['message'] = this.message.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.message = ChatMessageModel.create(json['message']);
	}

	static ChatReadMessageResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatReadMessageResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatRequestSupportRequestModel extends PublicAccessRequestModel {
	String name;
	String email;
	String phone;
	String document;

	ChatRequestSupportRequestModel({ String name, String email, String phone, String document, int organizationId }) : super(organizationId: organizationId){ 
		this.name = name;
		this.email = email;
		this.phone = phone;
		this.document = document;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['name'] = this.name;
		json['email'] = this.email;
		json['phone'] = this.phone;
		json['document'] = this.document;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.name = json['name'];
		this.email = json['email'];
		this.phone = json['phone'];
		this.document = json['document'];
	}

	static ChatRequestSupportRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatRequestSupportRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatRequestSupportResponseModel extends PublicAccessResponseModel {
	ChatUserModel user;
	ChatConversationModel conversation;
	bool noNewReason;

	ChatRequestSupportResponseModel({ ChatUserModel user, ChatConversationModel conversation, bool noNewReason,  }) : super(){ 
		this.user = user;
		this.conversation = conversation;
		this.noNewReason = noNewReason;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['user'] = this.user.toJson();
		json['conversation'] = this.conversation.toJson();
		json['noNewReason'] = this.noNewReason;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.user = ChatUserModel.create(json['user']);
		this.conversation = ChatConversationModel.create(json['conversation']);
		this.noNewReason = json['noNewReason'];
	}

	static ChatRequestSupportResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatRequestSupportResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatSendMessageRequestModel extends PublicAccessRequestModel {
	int conversationId;
	int chatUserId;
	String message;

	ChatSendMessageRequestModel({ int conversationId, int chatUserId, String message, int organizationId }) : super(organizationId: organizationId){ 
		this.conversationId = conversationId;
		this.chatUserId = chatUserId;
		this.message = message;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['conversationId'] = this.conversationId;
		json['chatUserId'] = this.chatUserId;
		json['message'] = this.message;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.conversationId = json['conversationId'];
		this.chatUserId = json['chatUserId'];
		this.message = json['message'];
	}

	static ChatSendMessageRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatSendMessageRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatSendMessageResponseModel extends PublicAccessResponseModel {
	int messageId;

	ChatSendMessageResponseModel({ int messageId,  }) : super(){ 
		this.messageId = messageId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['messageId'] = this.messageId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.messageId = json['messageId'];
	}

	static ChatSendMessageResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatSendMessageResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatSendMessageToAttendantRequestModel extends ChatSendMessageRequestModel {

	ChatSendMessageToAttendantRequestModel({ int conversationId, int chatUserId, String message, int organizationId }) : super(conversationId: conversationId, chatUserId: chatUserId, message: message, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatSendMessageToAttendantRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatSendMessageToAttendantRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatSendMessageToAttendantResponseModel extends ChatSendMessageResponseModel {

	ChatSendMessageToAttendantResponseModel({ int messageId,  }) : super(messageId: messageId, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatSendMessageToAttendantResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatSendMessageToAttendantResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatSendMessageToUserRequestModel extends ChatSendMessageRequestModel {

	ChatSendMessageToUserRequestModel({ int conversationId, int chatUserId, String message, int organizationId }) : super(conversationId: conversationId, chatUserId: chatUserId, message: message, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatSendMessageToUserRequestModel create(Map<String, dynamic> json) {
		var ret = new ChatSendMessageToUserRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatSendMessageToUserResponseModel extends ChatSendMessageResponseModel {

	ChatSendMessageToUserResponseModel({ int messageId,  }) : super(messageId: messageId, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ChatSendMessageToUserResponseModel create(Map<String, dynamic> json) {
		var ret = new ChatSendMessageToUserResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ChatUserModel {
	int id;
	int userId;
	String name;
	String email;
	String phone;
	String document;
	ChatUserType userType;

	ChatUserModel({ int id, int userId, String name, String email, String phone, String document, ChatUserType userType }){ 
		this.id = id;
		this.userId = userId;
		this.name = name;
		this.email = email;
		this.phone = phone;
		this.document = document;
		this.userType = userType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['userId'] = this.userId;
		json['name'] = this.name;
		json['email'] = this.email;
		json['phone'] = this.phone;
		json['document'] = this.document;
		json['userType'] = this.userType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.userId = json['userId'];
		this.name = json['name'];
		this.email = json['email'];
		this.phone = json['phone'];
		this.document = json['document'];
		this.userType = new ChatUserType(value: int.parse(json['userType'].toString()));
	}

	static ChatUserModel create(Map<String, dynamic> json) {
		var ret = new ChatUserModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ComponentModel {
	int id;
	String title;
	String html;
	String style;
	String code;

	ComponentModel({ int id, String title, String html, String style, String code }){ 
		this.id = id;
		this.title = title;
		this.html = html;
		this.style = style;
		this.code = code;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		json['html'] = this.html;
		json['style'] = this.style;
		json['code'] = this.code;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
		this.html = json['html'];
		this.style = json['style'];
		this.code = json['code'];
	}

	static ComponentModel create(Map<String, dynamic> json) {
		var ret = new ComponentModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class CredentialModel {
	int id;
	KeyPairInfoModel privateKey;
	BeeUserModel user;
	int organizationId;
	String description;

	CredentialModel({ int id, KeyPairInfoModel privateKey, BeeUserModel user, int organizationId, String description }){ 
		this.id = id;
		this.privateKey = privateKey;
		this.user = user;
		this.organizationId = organizationId;
		this.description = description;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['privateKey'] = this.privateKey.toJson();
		json['user'] = this.user.toJson();
		json['organizationId'] = this.organizationId;
		json['description'] = this.description;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.privateKey = KeyPairInfoModel.create(json['privateKey']);
		this.user = BeeUserModel.create(json['user']);
		this.organizationId = json['organizationId'];
		this.description = json['description'];
	}

	static CredentialModel create(Map<String, dynamic> json) {
		var ret = new CredentialModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class DataTypeModel {
	int id;
	String title;

	DataTypeModel({ int id, String title }){ 
		this.id = id;
		this.title = title;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
	}

	static DataTypeModel create(Map<String, dynamic> json) {
		var ret = new DataTypeModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class DataValueModel {
	int id;
	String value;
	DataTypeModel dataType;

	DataValueModel({ int id, String value, DataTypeModel dataType }){ 
		this.id = id;
		this.value = value;
		this.dataType = dataType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['value'] = this.value;
		json['dataType'] = this.dataType.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.value = json['value'];
		this.dataType = DataTypeModel.create(json['dataType']);
	}

	static DataValueModel create(Map<String, dynamic> json) {
		var ret = new DataValueModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class DecryptedPassword {
	String name;
	CredentialType type;
	String contact;
	String password;

	DecryptedPassword({ String name, CredentialType type, String contact, String password }){ 
		this.name = name;
		this.type = type;
		this.contact = contact;
		this.password = password;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['name'] = this.name;
		json['type'] = this.type.value;
		json['contact'] = this.contact;
		json['password'] = this.password;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.name = json['name'];
		this.type = new CredentialType(value: int.parse(json['type'].toString()));
		this.contact = json['contact'];
		this.password = json['password'];
	}

	static DecryptedPassword create(Map<String, dynamic> json) {
		var ret = new DecryptedPassword();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class DownloadAdmins {
	String id;
	List<UploadAdmin> admins;

	DownloadAdmins({ String id, List<UploadAdmin> admins }){ 
		this.id = id;
		this.admins = admins;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.admins != null) json['admins'] = this.admins.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		if (json['admins'] != null) this.admins = new List<Map<String, dynamic>>.from(json['admins']).map((l) => UploadAdmin.create(l)).toList();
	}

	static DownloadAdmins create(Map<String, dynamic> json) {
		var ret = new DownloadAdmins();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class DownloadEvents {
	String id;
	List<EventModel> badEvents;
	int voteEvents;

	DownloadEvents({ String id, List<EventModel> badEvents, int voteEvents }){ 
		this.id = id;
		this.badEvents = badEvents;
		this.voteEvents = voteEvents;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.badEvents != null) json['badEvents'] = this.badEvents.map((e) => e.toJson()).toList();
		json['voteEvents'] = this.voteEvents;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		if (json['badEvents'] != null) this.badEvents = new List<Map<String, dynamic>>.from(json['badEvents']).map((l) => EventModel.create(l)).toList();
		this.voteEvents = json['voteEvents'];
	}

	static DownloadEvents create(Map<String, dynamic> json) {
		var ret = new DownloadEvents();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class DownloadEventsResponse {
	DownloadEvents result;

	DownloadEventsResponse({ DownloadEvents result }){ 
		this.result = result;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['result'] = this.result.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.result = DownloadEvents.create(json['result']);
	}

	static DownloadEventsResponse create(Map<String, dynamic> json) {
		var ret = new DownloadEventsResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class DownloadVoters {
	String id;
	List<UploadVoter> voters;

	DownloadVoters({ String id, List<UploadVoter> voters }){ 
		this.id = id;
		this.voters = voters;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.voters != null) json['voters'] = this.voters.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		if (json['voters'] != null) this.voters = new List<Map<String, dynamic>>.from(json['voters']).map((l) => UploadVoter.create(l)).toList();
	}

	static DownloadVoters create(Map<String, dynamic> json) {
		var ret = new DownloadVoters();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EmailProviderModel extends ProviderModel {
	EmailProviderType type;
	String sender;
	IEmailProvider provider;

	EmailProviderModel({ EmailProviderType type, String sender, IEmailProvider provider, String key1, String key2, String key3, String key4, String key5 }) : super(key1: key1, key2: key2, key3: key3, key4: key4, key5: key5){ 
		this.type = type;
		this.sender = sender;
		this.provider = provider;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['type'] = this.type.value;
		json['sender'] = this.sender;
		json['provider'] = this.provider;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.type = new EmailProviderType(value: int.parse(json['type'].toString()));
		this.sender = json['sender'];
		this.provider = json['provider'];
	}

	static EmailProviderModel create(Map<String, dynamic> json) {
		var ret = new EmailProviderModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EncryptedPINModel {
	int id;
	List<SecretShareGroupModel> groups;

	EncryptedPINModel({ int id, List<SecretShareGroupModel> groups }){ 
		this.id = id;
		this.groups = groups;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.groups != null) json['groups'] = this.groups.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		if (json['groups'] != null) this.groups = new List<Map<String, dynamic>>.from(json['groups']).map((l) => SecretShareGroupModel.create(l)).toList();
	}

	static EncryptedPINModel create(Map<String, dynamic> json) {
		var ret = new EncryptedPINModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EndSessionRequestModel extends PrivateAccessRequestModel {

	EndSessionRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static EndSessionRequestModel create(Map<String, dynamic> json) {
		var ret = new EndSessionRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EndSessionResponseModel extends PrivateAccessResponseModel {

	EndSessionResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static EndSessionResponseModel create(Map<String, dynamic> json) {
		var ret = new EndSessionResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EventModel {
	int id;
	String dateTime;
	String userAgent;
	String remoteIpAddress;
	String host;
	EventAction eventAction;
	String requestModel;
	String responseModel;
	String hash;
	String signature;
	int userId;
	int adminId;
	int organizationId;
	bool error;

	EventModel({ int id, String dateTime, String userAgent, String remoteIpAddress, String host, EventAction eventAction, String requestModel, String responseModel, String hash, String signature, int userId, int adminId, int organizationId, bool error }){ 
		this.id = id;
		this.dateTime = dateTime;
		this.userAgent = userAgent;
		this.remoteIpAddress = remoteIpAddress;
		this.host = host;
		this.eventAction = eventAction;
		this.requestModel = requestModel;
		this.responseModel = responseModel;
		this.hash = hash;
		this.signature = signature;
		this.userId = userId;
		this.adminId = adminId;
		this.organizationId = organizationId;
		this.error = error;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['dateTime'] = this.dateTime;
		json['userAgent'] = this.userAgent;
		json['remoteIpAddress'] = this.remoteIpAddress;
		json['host'] = this.host;
		json['eventAction'] = this.eventAction.value;
		json['requestModel'] = this.requestModel;
		json['responseModel'] = this.responseModel;
		json['hash'] = this.hash;
		json['signature'] = this.signature;
		json['userId'] = this.userId;
		json['adminId'] = this.adminId;
		json['organizationId'] = this.organizationId;
		json['error'] = this.error;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.dateTime = json['dateTime'];
		this.userAgent = json['userAgent'];
		this.remoteIpAddress = json['remoteIpAddress'];
		this.host = json['host'];
		this.eventAction = new EventAction(value: int.parse(json['eventAction'].toString()));
		this.requestModel = json['requestModel'];
		this.responseModel = json['responseModel'];
		this.hash = json['hash'];
		this.signature = json['signature'];
		this.userId = json['userId'];
		this.adminId = json['adminId'];
		this.organizationId = json['organizationId'];
		this.error = json['error'];
	}

	static EventModel create(Map<String, dynamic> json) {
		var ret = new EventModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EventMonitorItemModel {
	EventAction eventAction;
	bool error;
	DateTime dateTime;
	int count;

	EventMonitorItemModel({ EventAction eventAction, bool error, DateTime dateTime, int count }){ 
		this.eventAction = eventAction;
		this.error = error;
		this.dateTime = dateTime;
		this.count = count;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['eventAction'] = this.eventAction.value;
		json['error'] = this.error;
		if (this.dateTime != null) json['dateTime'] = CommonConversion.date2String(this.dateTime);
		json['count'] = this.count;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.eventAction = new EventAction(value: int.parse(json['eventAction'].toString()));
		this.error = json['error'];
		this.dateTime = CommonConversion.string2Date(json['dateTime']);
		this.count = json['count'];
	}

	static EventMonitorItemModel create(Map<String, dynamic> json) {
		var ret = new EventMonitorItemModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EventMonitorItemRequestModel extends PublicAccessRequestModel {

	EventMonitorItemRequestModel({ int organizationId }) : super(organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static EventMonitorItemRequestModel create(Map<String, dynamic> json) {
		var ret = new EventMonitorItemRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class EventMonitorItemResponseModel extends PublicAccessResponseModel {
	DateTime lastRefresh;
	List<EventMonitorItemModel> itens;

	EventMonitorItemResponseModel({ DateTime lastRefresh, List<EventMonitorItemModel> itens,  }) : super(){ 
		this.lastRefresh = lastRefresh;
		this.itens = itens;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.lastRefresh != null) json['lastRefresh'] = CommonConversion.date2String(this.lastRefresh);
		if (this.itens != null) json['itens'] = this.itens.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.lastRefresh = CommonConversion.string2Date(json['lastRefresh']);
		if (json['itens'] != null) this.itens = new List<Map<String, dynamic>>.from(json['itens']).map((l) => EventMonitorItemModel.create(l)).toList();
	}

	static EventMonitorItemResponseModel create(Map<String, dynamic> json) {
		var ret = new EventMonitorItemResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class FileContentModel {
	int id;
	String title;
	String fileName;
	DateTime lastSave;
	String content;

	FileContentModel({ int id, String title, String fileName, DateTime lastSave, String content }){ 
		this.id = id;
		this.title = title;
		this.fileName = fileName;
		this.lastSave = lastSave;
		this.content = content;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		json['fileName'] = this.fileName;
		if (this.lastSave != null) json['lastSave'] = CommonConversion.date2String(this.lastSave);
		json['content'] = this.content;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
		this.fileName = json['fileName'];
		this.lastSave = CommonConversion.string2Date(json['lastSave']);
		this.content = json['content'];
	}

	static FileContentModel create(Map<String, dynamic> json) {
		var ret = new FileContentModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ForcePoolStartRequestModel extends PrivateAccessRequestModel {
	int poolId;

	ForcePoolStartRequestModel({ int poolId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.poolId = poolId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['poolId'] = this.poolId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.poolId = json['poolId'];
	}

	static ForcePoolStartRequestModel create(Map<String, dynamic> json) {
		var ret = new ForcePoolStartRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ForcePoolStartResponseModel extends PrivateAccessResponseModel {

	ForcePoolStartResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ForcePoolStartResponseModel create(Map<String, dynamic> json) {
		var ret = new ForcePoolStartResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GeneratedPassword {
	String name;
	String encryptedPassword;
	String contact;
	CredentialType type;

	GeneratedPassword({ String name, String encryptedPassword, String contact, CredentialType type }){ 
		this.name = name;
		this.encryptedPassword = encryptedPassword;
		this.contact = contact;
		this.type = type;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['name'] = this.name;
		json['encryptedPassword'] = this.encryptedPassword;
		json['contact'] = this.contact;
		json['type'] = this.type.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.name = json['name'];
		this.encryptedPassword = json['encryptedPassword'];
		this.contact = json['contact'];
		this.type = new CredentialType(value: int.parse(json['type'].toString()));
	}

	static GeneratedPassword create(Map<String, dynamic> json) {
		var ret = new GeneratedPassword();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GeneratedPasswords {
	bool isToken;
	String encryptionKey;
	String encryptionIV;
	List<GeneratedPassword> passwords;

	GeneratedPasswords({ bool isToken, String encryptionKey, String encryptionIV, List<GeneratedPassword> passwords }){ 
		this.isToken = isToken;
		this.encryptionKey = encryptionKey;
		this.encryptionIV = encryptionIV;
		this.passwords = passwords;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['isToken'] = this.isToken;
		json['encryptionKey'] = this.encryptionKey;
		json['encryptionIV'] = this.encryptionIV;
		if (this.passwords != null) json['passwords'] = this.passwords.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.isToken = json['isToken'];
		this.encryptionKey = json['encryptionKey'];
		this.encryptionIV = json['encryptionIV'];
		if (json['passwords'] != null) this.passwords = new List<Map<String, dynamic>>.from(json['passwords']).map((l) => GeneratedPassword.create(l)).toList();
	}

	static GeneratedPasswords create(Map<String, dynamic> json) {
		var ret = new GeneratedPasswords();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GenerateFaceToFaceBallotBoxCodeRequestModel extends PrivateAccessRequestModel {
	int ballotBoxId;

	GenerateFaceToFaceBallotBoxCodeRequestModel({ int ballotBoxId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.ballotBoxId = ballotBoxId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['ballotBoxId'] = this.ballotBoxId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.ballotBoxId = json['ballotBoxId'];
	}

	static GenerateFaceToFaceBallotBoxCodeRequestModel create(Map<String, dynamic> json) {
		var ret = new GenerateFaceToFaceBallotBoxCodeRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GenerateFaceToFaceBallotBoxCodeResponseModel extends PrivateAccessResponseModel {
	String code;

	GenerateFaceToFaceBallotBoxCodeResponseModel({ String code, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.code = code;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['code'] = this.code;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.code = json['code'];
	}

	static GenerateFaceToFaceBallotBoxCodeResponseModel create(Map<String, dynamic> json) {
		var ret = new GenerateFaceToFaceBallotBoxCodeResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetAdminEventRequestModel extends PrivateAccessRequestModel {
	int userId;
	EventAction eventAction;

	GetAdminEventRequestModel({ int userId, EventAction eventAction, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.userId = userId;
		this.eventAction = eventAction;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		json['eventAction'] = this.eventAction.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
		this.eventAction = new EventAction(value: int.parse(json['eventAction'].toString()));
	}

	static GetAdminEventRequestModel create(Map<String, dynamic> json) {
		var ret = new GetAdminEventRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetAdminEventResponseModel extends PrivateAccessResponseModel {
	List<VoterEventModel> events;

	GetAdminEventResponseModel({ List<VoterEventModel> events, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.events = events;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.events != null) json['events'] = this.events.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['events'] != null) this.events = new List<Map<String, dynamic>>.from(json['events']).map((l) => VoterEventModel.create(l)).toList();
	}

	static GetAdminEventResponseModel create(Map<String, dynamic> json) {
		var ret = new GetAdminEventResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetChallengeRequestModel extends PublicAccessRequestModel {

	GetChallengeRequestModel({ int organizationId }) : super(organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static GetChallengeRequestModel create(Map<String, dynamic> json) {
		var ret = new GetChallengeRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetChallengeResponseModel extends PrivateAccessResponseModel {

	GetChallengeResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static GetChallengeResponseModel create(Map<String, dynamic> json) {
		var ret = new GetChallengeResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetIPEventRequestModel extends PrivateAccessRequestModel {
	String remoteIpAddress;

	GetIPEventRequestModel({ String remoteIpAddress, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.remoteIpAddress = remoteIpAddress;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['remoteIpAddress'] = this.remoteIpAddress;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.remoteIpAddress = json['remoteIpAddress'];
	}

	static GetIPEventRequestModel create(Map<String, dynamic> json) {
		var ret = new GetIPEventRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetIPEventResponseModel extends PrivateAccessResponseModel {
	List<VoterEventModel> events;

	GetIPEventResponseModel({ List<VoterEventModel> events, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.events = events;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.events != null) json['events'] = this.events.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['events'] != null) this.events = new List<Map<String, dynamic>>.from(json['events']).map((l) => VoterEventModel.create(l)).toList();
	}

	static GetIPEventResponseModel create(Map<String, dynamic> json) {
		var ret = new GetIPEventResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetPasswordForCertificateRequestModel extends PublicAccessRequestModel {
	String certificateB64;

	GetPasswordForCertificateRequestModel({ String certificateB64, int organizationId }) : super(organizationId: organizationId){ 
		this.certificateB64 = certificateB64;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['certificateB64'] = this.certificateB64;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.certificateB64 = json['certificateB64'];
	}

	static GetPasswordForCertificateRequestModel create(Map<String, dynamic> json) {
		var ret = new GetPasswordForCertificateRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetPasswordForCertificateResponseModel extends PrivateAccessResponseModel {
	String contact;
	String encryptedPassword;

	GetPasswordForCertificateResponseModel({ String contact, String encryptedPassword, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.contact = contact;
		this.encryptedPassword = encryptedPassword;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['contact'] = this.contact;
		json['encryptedPassword'] = this.encryptedPassword;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.contact = json['contact'];
		this.encryptedPassword = json['encryptedPassword'];
	}

	static GetPasswordForCertificateResponseModel create(Map<String, dynamic> json) {
		var ret = new GetPasswordForCertificateResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetPositiveIdentificationChallengeRequestModel extends PublicAccessRequestModel {
	String contact;
	CredentialType contactType;

	GetPositiveIdentificationChallengeRequestModel({ String contact, CredentialType contactType, int organizationId }) : super(organizationId: organizationId){ 
		this.contact = contact;
		this.contactType = contactType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
	}

	static GetPositiveIdentificationChallengeRequestModel create(Map<String, dynamic> json) {
		var ret = new GetPositiveIdentificationChallengeRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetPositiveIdentificationChallengeResponseModel extends PublicAccessResponseModel {
	PositiveIdentificationChallengeModel challenge;

	GetPositiveIdentificationChallengeResponseModel({ PositiveIdentificationChallengeModel challenge,  }) : super(){ 
		this.challenge = challenge;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['challenge'] = this.challenge.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.challenge = PositiveIdentificationChallengeModel.create(json['challenge']);
	}

	static GetPositiveIdentificationChallengeResponseModel create(Map<String, dynamic> json) {
		var ret = new GetPositiveIdentificationChallengeResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetUserAgentEventRequestModel extends PrivateAccessRequestModel {
	EventAction eventAction;
	String userAgent;

	GetUserAgentEventRequestModel({ EventAction eventAction, String userAgent, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.eventAction = eventAction;
		this.userAgent = userAgent;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['eventAction'] = this.eventAction.value;
		json['userAgent'] = this.userAgent;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.eventAction = new EventAction(value: int.parse(json['eventAction'].toString()));
		this.userAgent = json['userAgent'];
	}

	static GetUserAgentEventRequestModel create(Map<String, dynamic> json) {
		var ret = new GetUserAgentEventRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetUserAgentEventResponseModel extends PrivateAccessResponseModel {
	List<VoterEventModel> events;

	GetUserAgentEventResponseModel({ List<VoterEventModel> events, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.events = events;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.events != null) json['events'] = this.events.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['events'] != null) this.events = new List<Map<String, dynamic>>.from(json['events']).map((l) => VoterEventModel.create(l)).toList();
	}

	static GetUserAgentEventResponseModel create(Map<String, dynamic> json) {
		var ret = new GetUserAgentEventResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetUserContactsModel {
	int credentialId;
	String contact;
	CredentialType contactType;

	GetUserContactsModel({ int credentialId, String contact, CredentialType contactType }){ 
		this.credentialId = credentialId;
		this.contact = contact;
		this.contactType = contactType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['credentialId'] = this.credentialId;
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.credentialId = json['credentialId'];
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
	}

	static GetUserContactsModel create(Map<String, dynamic> json) {
		var ret = new GetUserContactsModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetUserContactsRequestModel extends RequestTokenRequestModel {
	String contact;
	CredentialType contactType;

	GetUserContactsRequestModel({ String contact, CredentialType contactType, int organizationId }) : super(organizationId: organizationId){ 
		this.contact = contact;
		this.contactType = contactType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
	}

	static GetUserContactsRequestModel create(Map<String, dynamic> json) {
		var ret = new GetUserContactsRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetUserContactsResponseModel extends TokenByLinkResponseModel {
	List<GetUserContactsModel> contacts;

	GetUserContactsResponseModel({ List<GetUserContactsModel> contacts, String pkcs12, int iterationCount, String pinSalt, int tokenId, String tokenDoubleHash, String link,  }) : super(pkcs12: pkcs12, iterationCount: iterationCount, pinSalt: pinSalt, tokenId: tokenId, tokenDoubleHash: tokenDoubleHash, link: link, ){ 
		this.contacts = contacts;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.contacts != null) json['contacts'] = this.contacts.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['contacts'] != null) this.contacts = new List<Map<String, dynamic>>.from(json['contacts']).map((l) => GetUserContactsModel.create(l)).toList();
	}

	static GetUserContactsResponseModel create(Map<String, dynamic> json) {
		var ret = new GetUserContactsResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetUserEventRequestModel extends PrivateAccessRequestModel {
	int userId;

	GetUserEventRequestModel({ int userId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.userId = userId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
	}

	static GetUserEventRequestModel create(Map<String, dynamic> json) {
		var ret = new GetUserEventRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class GetUserEventResponseModel extends PrivateAccessResponseModel {
	List<VoterEventModel> events;

	GetUserEventResponseModel({ List<VoterEventModel> events, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.events = events;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.events != null) json['events'] = this.events.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['events'] != null) this.events = new List<Map<String, dynamic>>.from(json['events']).map((l) => VoterEventModel.create(l)).toList();
	}

	static GetUserEventResponseModel create(Map<String, dynamic> json) {
		var ret = new GetUserEventResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ImportPositiveIdentificationNamesRequestModel extends PrivateAccessRequestModel {

	ImportPositiveIdentificationNamesRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ImportPositiveIdentificationNamesRequestModel create(Map<String, dynamic> json) {
		var ret = new ImportPositiveIdentificationNamesRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ImportPositiveIdentificationNamesResponseModel extends PrivateAccessResponseModel {
	String result;

	ImportPositiveIdentificationNamesResponseModel({ String result, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.result = result;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['result'] = this.result;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.result = json['result'];
	}

	static ImportPositiveIdentificationNamesResponseModel create(Map<String, dynamic> json) {
		var ret = new ImportPositiveIdentificationNamesResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ImportVotersRequestModel extends PrivateAccessRequestModel {

	ImportVotersRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ImportVotersRequestModel create(Map<String, dynamic> json) {
		var ret = new ImportVotersRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ImportVotersResponseModel extends PrivateAccessResponseModel {
	String xmlB64;

	ImportVotersResponseModel({ String xmlB64, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.xmlB64 = xmlB64;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['xmlB64'] = this.xmlB64;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.xmlB64 = json['xmlB64'];
	}

	static ImportVotersResponseModel create(Map<String, dynamic> json) {
		var ret = new ImportVotersResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class InitializeRequest {

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
	}

	static InitializeRequest create(Map<String, dynamic> json) {
		var ret = new InitializeRequest();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class InitializeResponse {
	OrganizationModel organization;

	InitializeResponse({ OrganizationModel organization }){ 
		this.organization = organization;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['organization'] = this.organization.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.organization = OrganizationModel.create(json['organization']);
	}

	static InitializeResponse create(Map<String, dynamic> json) {
		var ret = new InitializeResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class InvalidateVoteRequestModel extends PrivateAccessRequestModel {
	int userId;
	int poolId;

	InvalidateVoteRequestModel({ int userId, int poolId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.userId = userId;
		this.poolId = poolId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		json['poolId'] = this.poolId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
		this.poolId = json['poolId'];
	}

	static InvalidateVoteRequestModel create(Map<String, dynamic> json) {
		var ret = new InvalidateVoteRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class InvalidateVoteResponseModel extends PrivateAccessResponseModel {

	InvalidateVoteResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static InvalidateVoteResponseModel create(Map<String, dynamic> json) {
		var ret = new InvalidateVoteResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class IpManagerModel {
	int id;
	String remoteIpAddress;
	IpManageableType type;

	IpManagerModel({ int id, String remoteIpAddress, IpManageableType type }){ 
		this.id = id;
		this.remoteIpAddress = remoteIpAddress;
		this.type = type;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['remoteIpAddress'] = this.remoteIpAddress;
		json['type'] = this.type.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.remoteIpAddress = json['remoteIpAddress'];
		this.type = new IpManageableType(value: int.parse(json['type'].toString()));
	}

	static IpManagerModel create(Map<String, dynamic> json) {
		var ret = new IpManagerModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class KeyPairInfoModel {
	int id;
	String publicKey;
	String publicKeyModulus;
	String publicKeyExponent;
	String thumbprint;
	String certificate;
	String pkcs12;
	int iterationCount;
	String pinSalt;
	EncryptedPINModel encryptedPIN;

	KeyPairInfoModel({ int id, String publicKey, String publicKeyModulus, String publicKeyExponent, String thumbprint, String certificate, String pkcs12, int iterationCount, String pinSalt, EncryptedPINModel encryptedPIN }){ 
		this.id = id;
		this.publicKey = publicKey;
		this.publicKeyModulus = publicKeyModulus;
		this.publicKeyExponent = publicKeyExponent;
		this.thumbprint = thumbprint;
		this.certificate = certificate;
		this.pkcs12 = pkcs12;
		this.iterationCount = iterationCount;
		this.pinSalt = pinSalt;
		this.encryptedPIN = encryptedPIN;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['publicKey'] = this.publicKey;
		json['publicKeyModulus'] = this.publicKeyModulus;
		json['publicKeyExponent'] = this.publicKeyExponent;
		json['thumbprint'] = this.thumbprint;
		json['certificate'] = this.certificate;
		json['pkcs12'] = this.pkcs12;
		json['iterationCount'] = this.iterationCount;
		json['pinSalt'] = this.pinSalt;
		json['encryptedPIN'] = this.encryptedPIN.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.publicKey = json['publicKey'];
		this.publicKeyModulus = json['publicKeyModulus'];
		this.publicKeyExponent = json['publicKeyExponent'];
		this.thumbprint = json['thumbprint'];
		this.certificate = json['certificate'];
		this.pkcs12 = json['pkcs12'];
		this.iterationCount = json['iterationCount'];
		this.pinSalt = json['pinSalt'];
		this.encryptedPIN = EncryptedPINModel.create(json['encryptedPIN']);
	}

	static KeyPairInfoModel create(Map<String, dynamic> json) {
		var ret = new KeyPairInfoModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class LargeFileRequestModel {
	String partB64;
	bool first;

	LargeFileRequestModel({ String partB64, bool first }){ 
		this.partB64 = partB64;
		this.first = first;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['partB64'] = this.partB64;
		json['first'] = this.first;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.partB64 = json['partB64'];
		this.first = json['first'];
	}

	static LargeFileRequestModel create(Map<String, dynamic> json) {
		var ret = new LargeFileRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class LargeFileResponseModel {

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
	}

	static LargeFileResponseModel create(Map<String, dynamic> json) {
		var ret = new LargeFileResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ListManagedIpsRequestModel extends PrivateAccessRequestModel {

	ListManagedIpsRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ListManagedIpsRequestModel create(Map<String, dynamic> json) {
		var ret = new ListManagedIpsRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ListManagedIpsResponseModel extends PrivateAccessResponseModel {
	List<RemoteIpInformation> managedIps;

	ListManagedIpsResponseModel({ List<RemoteIpInformation> managedIps, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.managedIps = managedIps;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.managedIps != null) json['managedIps'] = this.managedIps.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['managedIps'] != null) this.managedIps = new List<Map<String, dynamic>>.from(json['managedIps']).map((l) => RemoteIpInformation.create(l)).toList();
	}

	static ListManagedIpsResponseModel create(Map<String, dynamic> json) {
		var ret = new ListManagedIpsResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ListRegisteredPINsRequestModel extends PrivateAccessRequestModel {

	ListRegisteredPINsRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ListRegisteredPINsRequestModel create(Map<String, dynamic> json) {
		var ret = new ListRegisteredPINsRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ListRegisteredPINsResponseModel extends PrivateAccessResponseModel {
	List<RegisteredPINModel> registereds;

	ListRegisteredPINsResponseModel({ List<RegisteredPINModel> registereds, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.registereds = registereds;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.registereds != null) json['registereds'] = this.registereds.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['registereds'] != null) this.registereds = new List<Map<String, dynamic>>.from(json['registereds']).map((l) => RegisteredPINModel.create(l)).toList();
	}

	static ListRegisteredPINsResponseModel create(Map<String, dynamic> json) {
		var ret = new ListRegisteredPINsResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ListSharedGroupsRequestModel extends PrivateAccessRequestModel {

	ListSharedGroupsRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ListSharedGroupsRequestModel create(Map<String, dynamic> json) {
		var ret = new ListSharedGroupsRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ListSharedGroupsResponseModel extends PrivateAccessResponseModel {
	List<SecretShareGroupModel> groups;

	ListSharedGroupsResponseModel({ List<SecretShareGroupModel> groups, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.groups = groups;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.groups != null) json['groups'] = this.groups.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['groups'] != null) this.groups = new List<Map<String, dynamic>>.from(json['groups']).map((l) => SecretShareGroupModel.create(l)).toList();
	}

	static ListSharedGroupsResponseModel create(Map<String, dynamic> json) {
		var ret = new ListSharedGroupsResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class LoginFaceToFaceBallotBoxRequestModel extends PrivateAccessRequestModel {
	String codeHash;

	LoginFaceToFaceBallotBoxRequestModel({ String codeHash, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.codeHash = codeHash;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['codeHash'] = this.codeHash;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.codeHash = json['codeHash'];
	}

	static LoginFaceToFaceBallotBoxRequestModel create(Map<String, dynamic> json) {
		var ret = new LoginFaceToFaceBallotBoxRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class LoginFaceToFaceBallotBoxResponseModel extends PrivateAccessResponseModel {
	BallotBoxModel ballotBox;

	LoginFaceToFaceBallotBoxResponseModel({ BallotBoxModel ballotBox, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.ballotBox = ballotBox;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['ballotBox'] = this.ballotBox.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.ballotBox = BallotBoxModel.create(json['ballotBox']);
	}

	static LoginFaceToFaceBallotBoxResponseModel create(Map<String, dynamic> json) {
		var ret = new LoginFaceToFaceBallotBoxResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MeetingModel {
	int id;
	String title;
	int order;
	ComponentModel beforeMeetingHome;
	ComponentModel home;
	ComponentModel afterMeetingHome;
	ComponentModel votingBallot;
	ComponentModel receipt;
	List<PoolModel> pools;

	MeetingModel({ int id, String title, int order, ComponentModel beforeMeetingHome, ComponentModel home, ComponentModel afterMeetingHome, ComponentModel votingBallot, ComponentModel receipt, List<PoolModel> pools }){ 
		this.id = id;
		this.title = title;
		this.order = order;
		this.beforeMeetingHome = beforeMeetingHome;
		this.home = home;
		this.afterMeetingHome = afterMeetingHome;
		this.votingBallot = votingBallot;
		this.receipt = receipt;
		this.pools = pools;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		json['order'] = this.order;
		json['beforeMeetingHome'] = this.beforeMeetingHome.toJson();
		json['home'] = this.home.toJson();
		json['afterMeetingHome'] = this.afterMeetingHome.toJson();
		json['votingBallot'] = this.votingBallot.toJson();
		json['receipt'] = this.receipt.toJson();
		if (this.pools != null) json['pools'] = this.pools.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
		this.order = json['order'];
		this.beforeMeetingHome = ComponentModel.create(json['beforeMeetingHome']);
		this.home = ComponentModel.create(json['home']);
		this.afterMeetingHome = ComponentModel.create(json['afterMeetingHome']);
		this.votingBallot = ComponentModel.create(json['votingBallot']);
		this.receipt = ComponentModel.create(json['receipt']);
		if (json['pools'] != null) this.pools = new List<Map<String, dynamic>>.from(json['pools']).map((l) => PoolModel.create(l)).toList();
	}

	static MeetingModel create(Map<String, dynamic> json) {
		var ret = new MeetingModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MeetingResult {
	String id;
	MeetingModel meeting;
	List<PoolResult> results;
	List<BallotBoxResult> resultsByBallotBox;
	List<VoterResult> resultsByVoter;
	List<MixVoteResponse> encryptionErros;

	MeetingResult({ String id, MeetingModel meeting, List<PoolResult> results, List<BallotBoxResult> resultsByBallotBox, List<VoterResult> resultsByVoter, List<MixVoteResponse> encryptionErros }){ 
		this.id = id;
		this.meeting = meeting;
		this.results = results;
		this.resultsByBallotBox = resultsByBallotBox;
		this.resultsByVoter = resultsByVoter;
		this.encryptionErros = encryptionErros;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['meeting'] = this.meeting.toJson();
		if (this.results != null) json['results'] = this.results.map((e) => e.toJson()).toList();
		if (this.resultsByBallotBox != null) json['resultsByBallotBox'] = this.resultsByBallotBox.map((e) => e.toJson()).toList();
		if (this.resultsByVoter != null) json['resultsByVoter'] = this.resultsByVoter.map((e) => e.toJson()).toList();
		if (this.encryptionErros != null) json['encryptionErros'] = this.encryptionErros.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.meeting = MeetingModel.create(json['meeting']);
		if (json['results'] != null) this.results = new List<Map<String, dynamic>>.from(json['results']).map((l) => PoolResult.create(l)).toList();
		if (json['resultsByBallotBox'] != null) this.resultsByBallotBox = new List<Map<String, dynamic>>.from(json['resultsByBallotBox']).map((l) => BallotBoxResult.create(l)).toList();
		if (json['resultsByVoter'] != null) this.resultsByVoter = new List<Map<String, dynamic>>.from(json['resultsByVoter']).map((l) => VoterResult.create(l)).toList();
		if (json['encryptionErros'] != null) this.encryptionErros = new List<Map<String, dynamic>>.from(json['encryptionErros']).map((l) => MixVoteResponse.create(l)).toList();
	}

	static MeetingResult create(Map<String, dynamic> json) {
		var ret = new MeetingResult();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MixInvalidVoteResponse {
	String reason;
	VoteModel vote;

	MixInvalidVoteResponse({ String reason, VoteModel vote }){ 
		this.reason = reason;
		this.vote = vote;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['reason'] = this.reason;
		json['vote'] = this.vote.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.reason = json['reason'];
		this.vote = VoteModel.create(json['vote']);
	}

	static MixInvalidVoteResponse create(Map<String, dynamic> json) {
		var ret = new MixInvalidVoteResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MixReceiptResponse {
	String receiptResponse;
	int voterKeyId;
	int poolId;

	MixReceiptResponse({ String receiptResponse, int voterKeyId, int poolId }){ 
		this.receiptResponse = receiptResponse;
		this.voterKeyId = voterKeyId;
		this.poolId = poolId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['receiptResponse'] = this.receiptResponse;
		json['voterKeyId'] = this.voterKeyId;
		json['poolId'] = this.poolId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.receiptResponse = json['receiptResponse'];
		this.voterKeyId = json['voterKeyId'];
		this.poolId = json['poolId'];
	}

	static MixReceiptResponse create(Map<String, dynamic> json) {
		var ret = new MixReceiptResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MixVoteResponse {
	String encryptedVote;
	int ballotBoxId;
	int userId;
	int poolId;
	String dateTime;

	MixVoteResponse({ String encryptedVote, int ballotBoxId, int userId, int poolId, String dateTime }){ 
		this.encryptedVote = encryptedVote;
		this.ballotBoxId = ballotBoxId;
		this.userId = userId;
		this.poolId = poolId;
		this.dateTime = dateTime;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['encryptedVote'] = this.encryptedVote;
		json['ballotBoxId'] = this.ballotBoxId;
		json['userId'] = this.userId;
		json['poolId'] = this.poolId;
		json['dateTime'] = this.dateTime;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.encryptedVote = json['encryptedVote'];
		this.ballotBoxId = json['ballotBoxId'];
		this.userId = json['userId'];
		this.poolId = json['poolId'];
		this.dateTime = json['dateTime'];
	}

	static MixVoteResponse create(Map<String, dynamic> json) {
		var ret = new MixVoteResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MixVotes {
	String id;
	List<MixVoteResponse> votes;
	List<MixReceiptResponse> receipts;
	List<MixInvalidVoteResponse> invalids;
	List<BeeUserModel> voters;
	List<BeeUserModel> nonVoters;
	DateTime date;

	MixVotes({ String id, List<MixVoteResponse> votes, List<MixReceiptResponse> receipts, List<MixInvalidVoteResponse> invalids, List<BeeUserModel> voters, List<BeeUserModel> nonVoters, DateTime date }){ 
		this.id = id;
		this.votes = votes;
		this.receipts = receipts;
		this.invalids = invalids;
		this.voters = voters;
		this.nonVoters = nonVoters;
		this.date = date;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.votes != null) json['votes'] = this.votes.map((e) => e.toJson()).toList();
		if (this.receipts != null) json['receipts'] = this.receipts.map((e) => e.toJson()).toList();
		if (this.invalids != null) json['invalids'] = this.invalids.map((e) => e.toJson()).toList();
		if (this.voters != null) json['voters'] = this.voters.map((e) => e.toJson()).toList();
		if (this.nonVoters != null) json['nonVoters'] = this.nonVoters.map((e) => e.toJson()).toList();
		if (this.date != null) json['date'] = CommonConversion.date2String(this.date);
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		if (json['votes'] != null) this.votes = new List<Map<String, dynamic>>.from(json['votes']).map((l) => MixVoteResponse.create(l)).toList();
		if (json['receipts'] != null) this.receipts = new List<Map<String, dynamic>>.from(json['receipts']).map((l) => MixReceiptResponse.create(l)).toList();
		if (json['invalids'] != null) this.invalids = new List<Map<String, dynamic>>.from(json['invalids']).map((l) => MixInvalidVoteResponse.create(l)).toList();
		if (json['voters'] != null) this.voters = new List<Map<String, dynamic>>.from(json['voters']).map((l) => BeeUserModel.create(l)).toList();
		if (json['nonVoters'] != null) this.nonVoters = new List<Map<String, dynamic>>.from(json['nonVoters']).map((l) => BeeUserModel.create(l)).toList();
		this.date = CommonConversion.string2Date(json['date']);
	}

	static MixVotes create(Map<String, dynamic> json) {
		var ret = new MixVotes();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MixVotesRequestModel extends PrivateAccessRequestModel {

	MixVotesRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static MixVotesRequestModel create(Map<String, dynamic> json) {
		var ret = new MixVotesRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MixVotesResponse {
	MixVotes result;

	MixVotesResponse({ MixVotes result }){ 
		this.result = result;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['result'] = this.result.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.result = MixVotes.create(json['result']);
	}

	static MixVotesResponse create(Map<String, dynamic> json) {
		var ret = new MixVotesResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class MixVotesResponseModel extends PrivateAccessResponseModel {
	String xmlB64;

	MixVotesResponseModel({ String xmlB64, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.xmlB64 = xmlB64;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['xmlB64'] = this.xmlB64;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.xmlB64 = json['xmlB64'];
	}

	static MixVotesResponseModel create(Map<String, dynamic> json) {
		var ret = new MixVotesResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class OrganizationModel {
	int id;
	String title;
	String domain;
	String style;
	String emailProvider;
	String sMSProvider;
	String newPasswordEmailSubjectTemplate;
	String newPasswordEmailTemplate;
	String newPasswordSMSTemplate;
	String forgotPasswordEmailSubjectTemplate;
	String forgotPasswordEmailTemplate;
	String forgotPasswordSMSTemplate;
	String createNewPasswordEmailSubjectTemplate;
	String createNewPasswordEmailTemplate;
	String createNewPasswordSMSTemplate;
	ComponentModel home;
	ComponentModel votingBallot;
	ComponentModel receipt;
	ComponentModel resetPassword;
	ComponentModel titleArea;
	List<ComponentModel> components;
	List<FileContentModel> resources;
	List<MeetingModel> meetings;
	KeyPairInfoModel privateKey;
	bool acceptRepeatedContacts;
	List<BallotBoxModel> faceToFaceBallotBoxes;
	PositiveIdentificationConfigurationModel positiveIdentificationConfiguration;

	OrganizationModel({ int id, String title, String domain, String style, String emailProvider, String sMSProvider, String newPasswordEmailSubjectTemplate, String newPasswordEmailTemplate, String newPasswordSMSTemplate, String forgotPasswordEmailSubjectTemplate, String forgotPasswordEmailTemplate, String forgotPasswordSMSTemplate, String createNewPasswordEmailSubjectTemplate, String createNewPasswordEmailTemplate, String createNewPasswordSMSTemplate, ComponentModel home, ComponentModel votingBallot, ComponentModel receipt, ComponentModel resetPassword, ComponentModel titleArea, List<ComponentModel> components, List<FileContentModel> resources, List<MeetingModel> meetings, KeyPairInfoModel privateKey, bool acceptRepeatedContacts, List<BallotBoxModel> faceToFaceBallotBoxes, PositiveIdentificationConfigurationModel positiveIdentificationConfiguration }){ 
		this.id = id;
		this.title = title;
		this.domain = domain;
		this.style = style;
		this.emailProvider = emailProvider;
		this.sMSProvider = sMSProvider;
		this.newPasswordEmailSubjectTemplate = newPasswordEmailSubjectTemplate;
		this.newPasswordEmailTemplate = newPasswordEmailTemplate;
		this.newPasswordSMSTemplate = newPasswordSMSTemplate;
		this.forgotPasswordEmailSubjectTemplate = forgotPasswordEmailSubjectTemplate;
		this.forgotPasswordEmailTemplate = forgotPasswordEmailTemplate;
		this.forgotPasswordSMSTemplate = forgotPasswordSMSTemplate;
		this.createNewPasswordEmailSubjectTemplate = createNewPasswordEmailSubjectTemplate;
		this.createNewPasswordEmailTemplate = createNewPasswordEmailTemplate;
		this.createNewPasswordSMSTemplate = createNewPasswordSMSTemplate;
		this.home = home;
		this.votingBallot = votingBallot;
		this.receipt = receipt;
		this.resetPassword = resetPassword;
		this.titleArea = titleArea;
		this.components = components;
		this.resources = resources;
		this.meetings = meetings;
		this.privateKey = privateKey;
		this.acceptRepeatedContacts = acceptRepeatedContacts;
		this.faceToFaceBallotBoxes = faceToFaceBallotBoxes;
		this.positiveIdentificationConfiguration = positiveIdentificationConfiguration;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		json['domain'] = this.domain;
		json['style'] = this.style;
		json['emailProvider'] = this.emailProvider;
		json['sMSProvider'] = this.sMSProvider;
		json['newPasswordEmailSubjectTemplate'] = this.newPasswordEmailSubjectTemplate;
		json['newPasswordEmailTemplate'] = this.newPasswordEmailTemplate;
		json['newPasswordSMSTemplate'] = this.newPasswordSMSTemplate;
		json['forgotPasswordEmailSubjectTemplate'] = this.forgotPasswordEmailSubjectTemplate;
		json['forgotPasswordEmailTemplate'] = this.forgotPasswordEmailTemplate;
		json['forgotPasswordSMSTemplate'] = this.forgotPasswordSMSTemplate;
		json['createNewPasswordEmailSubjectTemplate'] = this.createNewPasswordEmailSubjectTemplate;
		json['createNewPasswordEmailTemplate'] = this.createNewPasswordEmailTemplate;
		json['createNewPasswordSMSTemplate'] = this.createNewPasswordSMSTemplate;
		json['home'] = this.home.toJson();
		json['votingBallot'] = this.votingBallot.toJson();
		json['receipt'] = this.receipt.toJson();
		json['resetPassword'] = this.resetPassword.toJson();
		json['titleArea'] = this.titleArea.toJson();
		if (this.components != null) json['components'] = this.components.map((e) => e.toJson()).toList();
		if (this.resources != null) json['resources'] = this.resources.map((e) => e.toJson()).toList();
		if (this.meetings != null) json['meetings'] = this.meetings.map((e) => e.toJson()).toList();
		json['privateKey'] = this.privateKey.toJson();
		json['acceptRepeatedContacts'] = this.acceptRepeatedContacts;
		if (this.faceToFaceBallotBoxes != null) json['faceToFaceBallotBoxes'] = this.faceToFaceBallotBoxes.map((e) => e.toJson()).toList();
		json['positiveIdentificationConfiguration'] = this.positiveIdentificationConfiguration.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
		this.domain = json['domain'];
		this.style = json['style'];
		this.emailProvider = json['emailProvider'];
		this.sMSProvider = json['sMSProvider'];
		this.newPasswordEmailSubjectTemplate = json['newPasswordEmailSubjectTemplate'];
		this.newPasswordEmailTemplate = json['newPasswordEmailTemplate'];
		this.newPasswordSMSTemplate = json['newPasswordSMSTemplate'];
		this.forgotPasswordEmailSubjectTemplate = json['forgotPasswordEmailSubjectTemplate'];
		this.forgotPasswordEmailTemplate = json['forgotPasswordEmailTemplate'];
		this.forgotPasswordSMSTemplate = json['forgotPasswordSMSTemplate'];
		this.createNewPasswordEmailSubjectTemplate = json['createNewPasswordEmailSubjectTemplate'];
		this.createNewPasswordEmailTemplate = json['createNewPasswordEmailTemplate'];
		this.createNewPasswordSMSTemplate = json['createNewPasswordSMSTemplate'];
		this.home = ComponentModel.create(json['home']);
		this.votingBallot = ComponentModel.create(json['votingBallot']);
		this.receipt = ComponentModel.create(json['receipt']);
		this.resetPassword = ComponentModel.create(json['resetPassword']);
		this.titleArea = ComponentModel.create(json['titleArea']);
		if (json['components'] != null) this.components = new List<Map<String, dynamic>>.from(json['components']).map((l) => ComponentModel.create(l)).toList();
		if (json['resources'] != null) this.resources = new List<Map<String, dynamic>>.from(json['resources']).map((l) => FileContentModel.create(l)).toList();
		if (json['meetings'] != null) this.meetings = new List<Map<String, dynamic>>.from(json['meetings']).map((l) => MeetingModel.create(l)).toList();
		this.privateKey = KeyPairInfoModel.create(json['privateKey']);
		this.acceptRepeatedContacts = json['acceptRepeatedContacts'];
		if (json['faceToFaceBallotBoxes'] != null) this.faceToFaceBallotBoxes = new List<Map<String, dynamic>>.from(json['faceToFaceBallotBoxes']).map((l) => BallotBoxModel.create(l)).toList();
		this.positiveIdentificationConfiguration = PositiveIdentificationConfigurationModel.create(json['positiveIdentificationConfiguration']);
	}

	static OrganizationModel create(Map<String, dynamic> json) {
		var ret = new OrganizationModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolModel {
	int id;
	String title;
	int order;
	int maxVotes;
	bool correctVote;
	bool enabled;
	bool isSecret;
	DateTime enabledDate;
	DateTime disabledDate;
	DateTime start;
	DateTime finish;
	int tzOffset;
	ComponentModel home;
	ComponentModel votingBallot;
	ComponentModel receipt;
	List<PoolOptionModel> options;

	PoolModel({ int id, String title, int order, int maxVotes, bool correctVote, bool enabled, bool isSecret, DateTime enabledDate, DateTime disabledDate, DateTime start, DateTime finish, int tzOffset, ComponentModel home, ComponentModel votingBallot, ComponentModel receipt, List<PoolOptionModel> options }){ 
		this.id = id;
		this.title = title;
		this.order = order;
		this.maxVotes = maxVotes;
		this.correctVote = correctVote;
		this.enabled = enabled;
		this.isSecret = isSecret;
		this.enabledDate = enabledDate;
		this.disabledDate = disabledDate;
		this.start = start;
		this.finish = finish;
		this.tzOffset = tzOffset;
		this.home = home;
		this.votingBallot = votingBallot;
		this.receipt = receipt;
		this.options = options;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		json['order'] = this.order;
		json['maxVotes'] = this.maxVotes;
		json['correctVote'] = this.correctVote;
		json['enabled'] = this.enabled;
		json['isSecret'] = this.isSecret;
		if (this.enabledDate != null) json['enabledDate'] = CommonConversion.date2String(this.enabledDate);
		if (this.disabledDate != null) json['disabledDate'] = CommonConversion.date2String(this.disabledDate);
		if (this.start != null) json['start'] = CommonConversion.date2String(this.start);
		if (this.finish != null) json['finish'] = CommonConversion.date2String(this.finish);
		json['tzOffset'] = this.tzOffset;
		json['home'] = this.home.toJson();
		json['votingBallot'] = this.votingBallot.toJson();
		json['receipt'] = this.receipt.toJson();
		if (this.options != null) json['options'] = this.options.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
		this.order = json['order'];
		this.maxVotes = json['maxVotes'];
		this.correctVote = json['correctVote'];
		this.enabled = json['enabled'];
		this.isSecret = json['isSecret'];
		this.enabledDate = CommonConversion.string2Date(json['enabledDate']);
		this.disabledDate = CommonConversion.string2Date(json['disabledDate']);
		this.start = CommonConversion.string2Date(json['start']);
		this.finish = CommonConversion.string2Date(json['finish']);
		this.tzOffset = json['tzOffset'];
		this.home = ComponentModel.create(json['home']);
		this.votingBallot = ComponentModel.create(json['votingBallot']);
		this.receipt = ComponentModel.create(json['receipt']);
		if (json['options'] != null) this.options = new List<Map<String, dynamic>>.from(json['options']).map((l) => PoolOptionModel.create(l)).toList();
	}

	static PoolModel create(Map<String, dynamic> json) {
		var ret = new PoolModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolOptionModel {
	int id;
	String title;
	int order;
	ComponentModel home;

	PoolOptionModel({ int id, String title, int order, ComponentModel home }){ 
		this.id = id;
		this.title = title;
		this.order = order;
		this.home = home;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		json['order'] = this.order;
		json['home'] = this.home.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
		this.order = json['order'];
		this.home = ComponentModel.create(json['home']);
	}

	static PoolOptionModel create(Map<String, dynamic> json) {
		var ret = new PoolOptionModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolOptionResult {
	int count;
	int optionId;
	String option;
	PoolOptionModel optionModel;

	PoolOptionResult({ int count, int optionId, String option, PoolOptionModel optionModel }){ 
		this.count = count;
		this.optionId = optionId;
		this.option = option;
		this.optionModel = optionModel;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['count'] = this.count;
		json['optionId'] = this.optionId;
		json['option'] = this.option;
		json['optionModel'] = this.optionModel.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.count = json['count'];
		this.optionId = json['optionId'];
		this.option = json['option'];
		this.optionModel = PoolOptionModel.create(json['optionModel']);
	}

	static PoolOptionResult create(Map<String, dynamic> json) {
		var ret = new PoolOptionResult();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolResult {
	List<PoolOptionResult> results;
	int poolId;
	String pool;
	PoolModel poolModel;

	PoolResult({ List<PoolOptionResult> results, int poolId, String pool, PoolModel poolModel }){ 
		this.results = results;
		this.poolId = poolId;
		this.pool = pool;
		this.poolModel = poolModel;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		if (this.results != null) json['results'] = this.results.map((e) => e.toJson()).toList();
		json['poolId'] = this.poolId;
		json['pool'] = this.pool;
		json['poolModel'] = this.poolModel.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		if (json['results'] != null) this.results = new List<Map<String, dynamic>>.from(json['results']).map((l) => PoolOptionResult.create(l)).toList();
		this.poolId = json['poolId'];
		this.pool = json['pool'];
		this.poolModel = PoolModel.create(json['poolModel']);
	}

	static PoolResult create(Map<String, dynamic> json) {
		var ret = new PoolResult();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolsStatusRequestModel extends PrivateAccessRequestModel {

	PoolsStatusRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static PoolsStatusRequestModel create(Map<String, dynamic> json) {
		var ret = new PoolsStatusRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolsStatusResponseModel extends PrivateAccessResponseModel {
	List<PoolStatusResponseModel> pools;

	PoolsStatusResponseModel({ List<PoolStatusResponseModel> pools, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.pools = pools;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.pools != null) json['pools'] = this.pools.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['pools'] != null) this.pools = new List<Map<String, dynamic>>.from(json['pools']).map((l) => PoolStatusResponseModel.create(l)).toList();
	}

	static PoolsStatusResponseModel create(Map<String, dynamic> json) {
		var ret = new PoolsStatusResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolStatusResponseModel {
	int poolId;
	DateTime enabledDate;
	DateTime disabledDate;
	int enabledVoters;
	int connectedVoters;
	int enabledAndConnectedVoters;
	int registeredVotes;

	PoolStatusResponseModel({ int poolId, DateTime enabledDate, DateTime disabledDate, int enabledVoters, int connectedVoters, int enabledAndConnectedVoters, int registeredVotes }){ 
		this.poolId = poolId;
		this.enabledDate = enabledDate;
		this.disabledDate = disabledDate;
		this.enabledVoters = enabledVoters;
		this.connectedVoters = connectedVoters;
		this.enabledAndConnectedVoters = enabledAndConnectedVoters;
		this.registeredVotes = registeredVotes;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['poolId'] = this.poolId;
		if (this.enabledDate != null) json['enabledDate'] = CommonConversion.date2String(this.enabledDate);
		if (this.disabledDate != null) json['disabledDate'] = CommonConversion.date2String(this.disabledDate);
		json['enabledVoters'] = this.enabledVoters;
		json['connectedVoters'] = this.connectedVoters;
		json['enabledAndConnectedVoters'] = this.enabledAndConnectedVoters;
		json['registeredVotes'] = this.registeredVotes;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.poolId = json['poolId'];
		this.enabledDate = CommonConversion.string2Date(json['enabledDate']);
		this.disabledDate = CommonConversion.string2Date(json['disabledDate']);
		this.enabledVoters = json['enabledVoters'];
		this.connectedVoters = json['connectedVoters'];
		this.enabledAndConnectedVoters = json['enabledAndConnectedVoters'];
		this.registeredVotes = json['registeredVotes'];
	}

	static PoolStatusResponseModel create(Map<String, dynamic> json) {
		var ret = new PoolStatusResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PoolVoterResult {
	int poolId;
	String pool;
	int optionId;
	String option;
	String optionLine;
	String dateTime;

	PoolVoterResult({ int poolId, String pool, int optionId, String option, String optionLine, String dateTime }){ 
		this.poolId = poolId;
		this.pool = pool;
		this.optionId = optionId;
		this.option = option;
		this.optionLine = optionLine;
		this.dateTime = dateTime;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['poolId'] = this.poolId;
		json['pool'] = this.pool;
		json['optionId'] = this.optionId;
		json['option'] = this.option;
		json['optionLine'] = this.optionLine;
		json['dateTime'] = this.dateTime;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.poolId = json['poolId'];
		this.pool = json['pool'];
		this.optionId = json['optionId'];
		this.option = json['option'];
		this.optionLine = json['optionLine'];
		this.dateTime = json['dateTime'];
	}

	static PoolVoterResult create(Map<String, dynamic> json) {
		var ret = new PoolVoterResult();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PositiveIdentificationChallengeModel {
	int id;
	List<PositiveIdentificationChallengeQuestionModel> questions;

	PositiveIdentificationChallengeModel({ int id, List<PositiveIdentificationChallengeQuestionModel> questions }){ 
		this.id = id;
		this.questions = questions;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.questions != null) json['questions'] = this.questions.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		if (json['questions'] != null) this.questions = new List<Map<String, dynamic>>.from(json['questions']).map((l) => PositiveIdentificationChallengeQuestionModel.create(l)).toList();
	}

	static PositiveIdentificationChallengeModel create(Map<String, dynamic> json) {
		var ret = new PositiveIdentificationChallengeModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PositiveIdentificationChallengeQuestionModel {
	int id;
	PositiveIdentificationQuestionModel question;
	List<PositiveIdentificationChallengeQuestionOptionModel> options;

	PositiveIdentificationChallengeQuestionModel({ int id, PositiveIdentificationQuestionModel question, List<PositiveIdentificationChallengeQuestionOptionModel> options }){ 
		this.id = id;
		this.question = question;
		this.options = options;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['question'] = this.question.toJson();
		if (this.options != null) json['options'] = this.options.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.question = PositiveIdentificationQuestionModel.create(json['question']);
		if (json['options'] != null) this.options = new List<Map<String, dynamic>>.from(json['options']).map((l) => PositiveIdentificationChallengeQuestionOptionModel.create(l)).toList();
	}

	static PositiveIdentificationChallengeQuestionModel create(Map<String, dynamic> json) {
		var ret = new PositiveIdentificationChallengeQuestionModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PositiveIdentificationChallengeQuestionOptionModel {
	int id;
	String value;

	PositiveIdentificationChallengeQuestionOptionModel({ int id, String value }){ 
		this.id = id;
		this.value = value;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['value'] = this.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.value = json['value'];
	}

	static PositiveIdentificationChallengeQuestionOptionModel create(Map<String, dynamic> json) {
		var ret = new PositiveIdentificationChallengeQuestionOptionModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PositiveIdentificationConfigurationModel {
	int id;
	int numberOfQuestions;
	int minimalToCorrect;
	int maximumToIncorrect;
	List<PositiveIdentificationQuestionModel> questions;

	PositiveIdentificationConfigurationModel({ int id, int numberOfQuestions, int minimalToCorrect, int maximumToIncorrect, List<PositiveIdentificationQuestionModel> questions }){ 
		this.id = id;
		this.numberOfQuestions = numberOfQuestions;
		this.minimalToCorrect = minimalToCorrect;
		this.maximumToIncorrect = maximumToIncorrect;
		this.questions = questions;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['numberOfQuestions'] = this.numberOfQuestions;
		json['minimalToCorrect'] = this.minimalToCorrect;
		json['maximumToIncorrect'] = this.maximumToIncorrect;
		if (this.questions != null) json['questions'] = this.questions.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.numberOfQuestions = json['numberOfQuestions'];
		this.minimalToCorrect = json['minimalToCorrect'];
		this.maximumToIncorrect = json['maximumToIncorrect'];
		if (json['questions'] != null) this.questions = new List<Map<String, dynamic>>.from(json['questions']).map((l) => PositiveIdentificationQuestionModel.create(l)).toList();
	}

	static PositiveIdentificationConfigurationModel create(Map<String, dynamic> json) {
		var ret = new PositiveIdentificationConfigurationModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PositiveIdentificationNameDBModel {
	int id;
	String value;
	String dataType;

	PositiveIdentificationNameDBModel({ int id, String value, String dataType }){ 
		this.id = id;
		this.value = value;
		this.dataType = dataType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['value'] = this.value;
		json['dataType'] = this.dataType;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.value = json['value'];
		this.dataType = json['dataType'];
	}

	static PositiveIdentificationNameDBModel create(Map<String, dynamic> json) {
		var ret = new PositiveIdentificationNameDBModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PositiveIdentificationQuestionModel {
	int id;
	String title;
	String dataType;
	PositiveIdentificationQuestionType questionType;
	String noneOfAboveTitle;
	String mask;
	int numberOfOptions;
	String functionToShowValue;

	PositiveIdentificationQuestionModel({ int id, String title, String dataType, PositiveIdentificationQuestionType questionType, String noneOfAboveTitle, String mask, int numberOfOptions, String functionToShowValue }){ 
		this.id = id;
		this.title = title;
		this.dataType = dataType;
		this.questionType = questionType;
		this.noneOfAboveTitle = noneOfAboveTitle;
		this.mask = mask;
		this.numberOfOptions = numberOfOptions;
		this.functionToShowValue = functionToShowValue;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['title'] = this.title;
		json['dataType'] = this.dataType;
		json['questionType'] = this.questionType.value;
		json['noneOfAboveTitle'] = this.noneOfAboveTitle;
		json['mask'] = this.mask;
		json['numberOfOptions'] = this.numberOfOptions;
		json['functionToShowValue'] = this.functionToShowValue;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.title = json['title'];
		this.dataType = json['dataType'];
		this.questionType = new PositiveIdentificationQuestionType(value: int.parse(json['questionType'].toString()));
		this.noneOfAboveTitle = json['noneOfAboveTitle'];
		this.mask = json['mask'];
		this.numberOfOptions = json['numberOfOptions'];
		this.functionToShowValue = json['functionToShowValue'];
	}

	static PositiveIdentificationQuestionModel create(Map<String, dynamic> json) {
		var ret = new PositiveIdentificationQuestionModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PrivateAccessRequestModel extends PublicAccessRequestModel {
	int sessionId;
	int challengeId;
	String response;

	PrivateAccessRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(organizationId: organizationId){ 
		this.sessionId = sessionId;
		this.challengeId = challengeId;
		this.response = response;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['sessionId'] = this.sessionId;
		json['challengeId'] = this.challengeId;
		json['response'] = this.response;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.sessionId = json['sessionId'];
		this.challengeId = json['challengeId'];
		this.response = json['response'];
	}

	static PrivateAccessRequestModel create(Map<String, dynamic> json) {
		var ret = new PrivateAccessRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PrivateAccessResponseModel extends PublicAccessResponseModel {
	int challengeId;
	String challenge;

	PrivateAccessResponseModel({ int challengeId, String challenge,  }) : super(){ 
		this.challengeId = challengeId;
		this.challenge = challenge;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['challengeId'] = this.challengeId;
		json['challenge'] = this.challenge;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.challengeId = json['challengeId'];
		this.challenge = json['challenge'];
	}

	static PrivateAccessResponseModel create(Map<String, dynamic> json) {
		var ret = new PrivateAccessResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ProviderModel {
	String key1;
	String key2;
	String key3;
	String key4;
	String key5;

	ProviderModel({ String key1, String key2, String key3, String key4, String key5 }){ 
		this.key1 = key1;
		this.key2 = key2;
		this.key3 = key3;
		this.key4 = key4;
		this.key5 = key5;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['key1'] = this.key1;
		json['key2'] = this.key2;
		json['key3'] = this.key3;
		json['key4'] = this.key4;
		json['key5'] = this.key5;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.key1 = json['key1'];
		this.key2 = json['key2'];
		this.key3 = json['key3'];
		this.key4 = json['key4'];
		this.key5 = json['key5'];
	}

	static ProviderModel create(Map<String, dynamic> json) {
		var ret = new ProviderModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ProviderRequestModel {
	String name;
	String contact;
	String password;

	ProviderRequestModel({ String name, String contact, String password }){ 
		this.name = name;
		this.contact = contact;
		this.password = password;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['name'] = this.name;
		json['contact'] = this.contact;
		json['password'] = this.password;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.name = json['name'];
		this.contact = json['contact'];
		this.password = json['password'];
	}

	static ProviderRequestModel create(Map<String, dynamic> json) {
		var ret = new ProviderRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ProviderResponseModel {
	String guid;
	String contact;
	String response;

	ProviderResponseModel({ String guid, String contact, String response }){ 
		this.guid = guid;
		this.contact = contact;
		this.response = response;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['guid'] = this.guid;
		json['contact'] = this.contact;
		json['response'] = this.response;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.guid = json['guid'];
		this.contact = json['contact'];
		this.response = json['response'];
	}

	static ProviderResponseModel create(Map<String, dynamic> json) {
		var ret = new ProviderResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PublicAccessRequestModel {
	int organizationId;

	PublicAccessRequestModel({ int organizationId }){ 
		this.organizationId = organizationId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['organizationId'] = this.organizationId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.organizationId = json['organizationId'];
	}

	static PublicAccessRequestModel create(Map<String, dynamic> json) {
		var ret = new PublicAccessRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PublicAccessResponseModel {

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
	}

	static PublicAccessResponseModel create(Map<String, dynamic> json) {
		var ret = new PublicAccessResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PVoterCredentialModel {
	int id;
	String contact;
	CredentialType contactType;
	bool active;
	bool isCredential;

	PVoterCredentialModel({ int id, String contact, CredentialType contactType, bool active, bool isCredential }){ 
		this.id = id;
		this.contact = contact;
		this.contactType = contactType;
		this.active = active;
		this.isCredential = isCredential;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		json['active'] = this.active;
		json['isCredential'] = this.isCredential;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
		this.active = json['active'];
		this.isCredential = json['isCredential'];
	}

	static PVoterCredentialModel create(Map<String, dynamic> json) {
		var ret = new PVoterCredentialModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class PVoterModel {
	int voterId;
	int poolId;
	bool enabled;
	bool voted;
	int weighted;

	PVoterModel({ int voterId, int poolId, bool enabled, bool voted, int weighted }){ 
		this.voterId = voterId;
		this.poolId = poolId;
		this.enabled = enabled;
		this.voted = voted;
		this.weighted = weighted;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['voterId'] = this.voterId;
		json['poolId'] = this.poolId;
		json['enabled'] = this.enabled;
		json['voted'] = this.voted;
		json['weighted'] = this.weighted;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.voterId = json['voterId'];
		this.poolId = json['poolId'];
		this.enabled = json['enabled'];
		this.voted = json['voted'];
		this.weighted = json['weighted'];
	}

	static PVoterModel create(Map<String, dynamic> json) {
		var ret = new PVoterModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReadFaceToFaceBallotBoxesRequestModel extends PrivateAccessRequestModel {

	ReadFaceToFaceBallotBoxesRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ReadFaceToFaceBallotBoxesRequestModel create(Map<String, dynamic> json) {
		var ret = new ReadFaceToFaceBallotBoxesRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReadFaceToFaceBallotBoxesResponseModel extends PrivateAccessResponseModel {
	List<BallotBoxModel> ballotBoxes;

	ReadFaceToFaceBallotBoxesResponseModel({ List<BallotBoxModel> ballotBoxes, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.ballotBoxes = ballotBoxes;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.ballotBoxes != null) json['ballotBoxes'] = this.ballotBoxes.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['ballotBoxes'] != null) this.ballotBoxes = new List<Map<String, dynamic>>.from(json['ballotBoxes']).map((l) => BallotBoxModel.create(l)).toList();
	}

	static ReadFaceToFaceBallotBoxesResponseModel create(Map<String, dynamic> json) {
		var ret = new ReadFaceToFaceBallotBoxesResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReadUserRequestModel extends PrivateAccessRequestModel {

	ReadUserRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ReadUserRequestModel create(Map<String, dynamic> json) {
		var ret = new ReadUserRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReadUserResponseModel extends PrivateAccessResponseModel {
	BeeUserModel user;

	ReadUserResponseModel({ BeeUserModel user, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.user = user;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['user'] = this.user.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.user = BeeUserModel.create(json['user']);
	}

	static ReadUserResponseModel create(Map<String, dynamic> json) {
		var ret = new ReadUserResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReceiptVerifyRequestModel extends PublicAccessRequestModel {
	String contact;
	CredentialType contactType;
	String code;

	ReceiptVerifyRequestModel({ String contact, CredentialType contactType, String code, int organizationId }) : super(organizationId: organizationId){ 
		this.contact = contact;
		this.contactType = contactType;
		this.code = code;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		json['code'] = this.code;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
		this.code = json['code'];
	}

	static ReceiptVerifyRequestModel create(Map<String, dynamic> json) {
		var ret = new ReceiptVerifyRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReceiptVerifyResponseModel extends PublicAccessResponseModel {
	DateTime dateTime;
	int poolId;
	VoteVerify verify;

	ReceiptVerifyResponseModel({ DateTime dateTime, int poolId, VoteVerify verify,  }) : super(){ 
		this.dateTime = dateTime;
		this.poolId = poolId;
		this.verify = verify;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.dateTime != null) json['dateTime'] = CommonConversion.date2String(this.dateTime);
		json['poolId'] = this.poolId;
		json['verify'] = this.verify.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.dateTime = CommonConversion.string2Date(json['dateTime']);
		this.poolId = json['poolId'];
		this.verify = new VoteVerify(value: int.parse(json['verify'].toString()));
	}

	static ReceiptVerifyResponseModel create(Map<String, dynamic> json) {
		var ret = new ReceiptVerifyResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RegisteredPINModel {
	String pin;
	SecretShareGroupModel group;
	ShareModel share;

	RegisteredPINModel({ String pin, SecretShareGroupModel group, ShareModel share }){ 
		this.pin = pin;
		this.group = group;
		this.share = share;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['pin'] = this.pin;
		json['group'] = this.group.toJson();
		json['share'] = this.share.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.pin = json['pin'];
		this.group = SecretShareGroupModel.create(json['group']);
		this.share = ShareModel.create(json['share']);
	}

	static RegisteredPINModel create(Map<String, dynamic> json) {
		var ret = new RegisteredPINModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RegisterPINRequestModel extends PrivateAccessRequestModel {
	int secretShareGroupId;
	int shareId;
	String pin;

	RegisterPINRequestModel({ int secretShareGroupId, int shareId, String pin, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.secretShareGroupId = secretShareGroupId;
		this.shareId = shareId;
		this.pin = pin;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['secretShareGroupId'] = this.secretShareGroupId;
		json['shareId'] = this.shareId;
		json['pin'] = this.pin;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.secretShareGroupId = json['secretShareGroupId'];
		this.shareId = json['shareId'];
		this.pin = json['pin'];
	}

	static RegisterPINRequestModel create(Map<String, dynamic> json) {
		var ret = new RegisterPINRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RegisterPINResponseModel extends PrivateAccessResponseModel {

	RegisterPINResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static RegisterPINResponseModel create(Map<String, dynamic> json) {
		var ret = new RegisterPINResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReleaseIPRequestModel extends PrivateAccessRequestModel {
	String remoteIpAddress;

	ReleaseIPRequestModel({ String remoteIpAddress, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.remoteIpAddress = remoteIpAddress;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['remoteIpAddress'] = this.remoteIpAddress;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.remoteIpAddress = json['remoteIpAddress'];
	}

	static ReleaseIPRequestModel create(Map<String, dynamic> json) {
		var ret = new ReleaseIPRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ReleaseIPResponseModel extends PrivateAccessResponseModel {

	ReleaseIPResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ReleaseIPResponseModel create(Map<String, dynamic> json) {
		var ret = new ReleaseIPResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RemoteIpInformation {
	String remoteIpAddress;
	DateTime next;
	int count;
	IpManageableType ipType;
	int allEventCount;
	int loginEventCount;
	int voteEventCount;
	int adminEventCount;
	int listContactCount;
	int sendContactCount;

	RemoteIpInformation({ String remoteIpAddress, DateTime next, int count, IpManageableType ipType, int allEventCount, int loginEventCount, int voteEventCount, int adminEventCount, int listContactCount, int sendContactCount }){ 
		this.remoteIpAddress = remoteIpAddress;
		this.next = next;
		this.count = count;
		this.ipType = ipType;
		this.allEventCount = allEventCount;
		this.loginEventCount = loginEventCount;
		this.voteEventCount = voteEventCount;
		this.adminEventCount = adminEventCount;
		this.listContactCount = listContactCount;
		this.sendContactCount = sendContactCount;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['remoteIpAddress'] = this.remoteIpAddress;
		if (this.next != null) json['next'] = CommonConversion.date2String(this.next);
		json['count'] = this.count;
		json['ipType'] = this.ipType.value;
		json['allEventCount'] = this.allEventCount;
		json['loginEventCount'] = this.loginEventCount;
		json['voteEventCount'] = this.voteEventCount;
		json['adminEventCount'] = this.adminEventCount;
		json['listContactCount'] = this.listContactCount;
		json['sendContactCount'] = this.sendContactCount;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.remoteIpAddress = json['remoteIpAddress'];
		this.next = CommonConversion.string2Date(json['next']);
		this.count = json['count'];
		this.ipType = new IpManageableType(value: int.parse(json['ipType'].toString()));
		this.allEventCount = json['allEventCount'];
		this.loginEventCount = json['loginEventCount'];
		this.voteEventCount = json['voteEventCount'];
		this.adminEventCount = json['adminEventCount'];
		this.listContactCount = json['listContactCount'];
		this.sendContactCount = json['sendContactCount'];
	}

	static RemoteIpInformation create(Map<String, dynamic> json) {
		var ret = new RemoteIpInformation();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RemoveIpFromBlackListRequestModel extends PrivateAccessRequestModel {
	String remoteIpAddress;

	RemoveIpFromBlackListRequestModel({ String remoteIpAddress, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.remoteIpAddress = remoteIpAddress;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['remoteIpAddress'] = this.remoteIpAddress;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.remoteIpAddress = json['remoteIpAddress'];
	}

	static RemoveIpFromBlackListRequestModel create(Map<String, dynamic> json) {
		var ret = new RemoveIpFromBlackListRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RemoveIpFromBlackListResponseModel extends PrivateAccessResponseModel {

	RemoveIpFromBlackListResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static RemoveIpFromBlackListResponseModel create(Map<String, dynamic> json) {
		var ret = new RemoveIpFromBlackListResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RemoveIpFromWhiteListRequestModel extends PrivateAccessRequestModel {
	String remoteIpAddress;

	RemoveIpFromWhiteListRequestModel({ String remoteIpAddress, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.remoteIpAddress = remoteIpAddress;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['remoteIpAddress'] = this.remoteIpAddress;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.remoteIpAddress = json['remoteIpAddress'];
	}

	static RemoveIpFromWhiteListRequestModel create(Map<String, dynamic> json) {
		var ret = new RemoveIpFromWhiteListRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RemoveIpFromWhiteListResponseModel extends PrivateAccessResponseModel {

	RemoveIpFromWhiteListResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static RemoveIpFromWhiteListResponseModel create(Map<String, dynamic> json) {
		var ret = new RemoveIpFromWhiteListResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RenderTemplateUploadRequestModel extends PrivateAccessRequestModel {

	RenderTemplateUploadRequestModel({ int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static RenderTemplateUploadRequestModel create(Map<String, dynamic> json) {
		var ret = new RenderTemplateUploadRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RenderTemplateUploadResponseModel extends PrivateAccessResponseModel {

	RenderTemplateUploadResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static RenderTemplateUploadResponseModel create(Map<String, dynamic> json) {
		var ret = new RenderTemplateUploadResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RequestTokenRequestModel extends PublicAccessRequestModel {

	RequestTokenRequestModel({ int organizationId }) : super(organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static RequestTokenRequestModel create(Map<String, dynamic> json) {
		var ret = new RequestTokenRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class RequestTokenResponseModel extends PublicAccessResponseModel {
	int tokenId;
	String tokenDoubleHash;
	String link;

	RequestTokenResponseModel({ int tokenId, String tokenDoubleHash, String link,  }) : super(){ 
		this.tokenId = tokenId;
		this.tokenDoubleHash = tokenDoubleHash;
		this.link = link;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['tokenId'] = this.tokenId;
		json['tokenDoubleHash'] = this.tokenDoubleHash;
		json['link'] = this.link;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.tokenId = json['tokenId'];
		this.tokenDoubleHash = json['tokenDoubleHash'];
		this.link = json['link'];
	}

	static RequestTokenResponseModel create(Map<String, dynamic> json) {
		var ret = new RequestTokenResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ResetPasswordFinishRequestModel extends ResponseTokenRequestModel {
	String passwordHash;
	String pkcs12;
	int iterationCount;
	String pinSalt;

	ResetPasswordFinishRequestModel({ String passwordHash, String pkcs12, int iterationCount, String pinSalt, int tokenId, String hashToken, int organizationId }) : super(tokenId: tokenId, hashToken: hashToken, organizationId: organizationId){ 
		this.passwordHash = passwordHash;
		this.pkcs12 = pkcs12;
		this.iterationCount = iterationCount;
		this.pinSalt = pinSalt;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['passwordHash'] = this.passwordHash;
		json['pkcs12'] = this.pkcs12;
		json['iterationCount'] = this.iterationCount;
		json['pinSalt'] = this.pinSalt;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.passwordHash = json['passwordHash'];
		this.pkcs12 = json['pkcs12'];
		this.iterationCount = json['iterationCount'];
		this.pinSalt = json['pinSalt'];
	}

	static ResetPasswordFinishRequestModel create(Map<String, dynamic> json) {
		var ret = new ResetPasswordFinishRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ResetPasswordFinishResponseModel extends PublicAccessResponseModel {
	int credentialId;

	ResetPasswordFinishResponseModel({ int credentialId,  }) : super(){ 
		this.credentialId = credentialId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['credentialId'] = this.credentialId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.credentialId = json['credentialId'];
	}

	static ResetPasswordFinishResponseModel create(Map<String, dynamic> json) {
		var ret = new ResetPasswordFinishResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ResetPasswordStartRequestModel extends RequestTokenRequestModel {
	int credentialId;
	String contact;
	CredentialType contactType;

	ResetPasswordStartRequestModel({ int credentialId, String contact, CredentialType contactType, int organizationId }) : super(organizationId: organizationId){ 
		this.credentialId = credentialId;
		this.contact = contact;
		this.contactType = contactType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['credentialId'] = this.credentialId;
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.credentialId = json['credentialId'];
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
	}

	static ResetPasswordStartRequestModel create(Map<String, dynamic> json) {
		var ret = new ResetPasswordStartRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ResetPasswordStartResponseModel extends TokenByLinkResponseModel {
	String contact;
	CredentialType contactType;

	ResetPasswordStartResponseModel({ String contact, CredentialType contactType, String pkcs12, int iterationCount, String pinSalt, int tokenId, String tokenDoubleHash, String link,  }) : super(pkcs12: pkcs12, iterationCount: iterationCount, pinSalt: pinSalt, tokenId: tokenId, tokenDoubleHash: tokenDoubleHash, link: link, ){ 
		this.contact = contact;
		this.contactType = contactType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
	}

	static ResetPasswordStartResponseModel create(Map<String, dynamic> json) {
		var ret = new ResetPasswordStartResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ResponseTokenRequestModel extends PublicAccessRequestModel {
	int tokenId;
	String hashToken;

	ResponseTokenRequestModel({ int tokenId, String hashToken, int organizationId }) : super(organizationId: organizationId){ 
		this.tokenId = tokenId;
		this.hashToken = hashToken;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['tokenId'] = this.tokenId;
		json['hashToken'] = this.hashToken;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.tokenId = json['tokenId'];
		this.hashToken = json['hashToken'];
	}

	static ResponseTokenRequestModel create(Map<String, dynamic> json) {
		var ret = new ResponseTokenRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SaveConfigurationRequestModel extends PrivateAccessRequestModel {
	bool changeName;

	SaveConfigurationRequestModel({ bool changeName, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.changeName = changeName;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['changeName'] = this.changeName;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.changeName = json['changeName'];
	}

	static SaveConfigurationRequestModel create(Map<String, dynamic> json) {
		var ret = new SaveConfigurationRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SaveConfigurationResponseModel extends PrivateAccessResponseModel {

	SaveConfigurationResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static SaveConfigurationResponseModel create(Map<String, dynamic> json) {
		var ret = new SaveConfigurationResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SearchVoterByDocumentRequestModel extends PrivateAccessRequestModel {
	String document;

	SearchVoterByDocumentRequestModel({ String document, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.document = document;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['document'] = this.document;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.document = json['document'];
	}

	static SearchVoterByDocumentRequestModel create(Map<String, dynamic> json) {
		var ret = new SearchVoterByDocumentRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SearchVoterByDocumentResponseModel extends PrivateAccessResponseModel {
	VoterModel voter;

	SearchVoterByDocumentResponseModel({ VoterModel voter, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.voter = voter;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['voter'] = this.voter.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.voter = VoterModel.create(json['voter']);
	}

	static SearchVoterByDocumentResponseModel create(Map<String, dynamic> json) {
		var ret = new SearchVoterByDocumentResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SearchVoterRequestModel extends PrivateAccessRequestModel {
	int voterId;

	SearchVoterRequestModel({ int voterId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.voterId = voterId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['voterId'] = this.voterId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.voterId = json['voterId'];
	}

	static SearchVoterRequestModel create(Map<String, dynamic> json) {
		var ret = new SearchVoterRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SearchVoterResponseModel extends PrivateAccessResponseModel {
	VoterModel voter;

	SearchVoterResponseModel({ VoterModel voter, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.voter = voter;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['voter'] = this.voter.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.voter = VoterModel.create(json['voter']);
	}

	static SearchVoterResponseModel create(Map<String, dynamic> json) {
		var ret = new SearchVoterResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SearchVotersRequestModel extends PrivateAccessRequestModel {
	String filter;
	int start;
	int count;

	SearchVotersRequestModel({ String filter, int start, int count, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.filter = filter;
		this.start = start;
		this.count = count;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['filter'] = this.filter;
		json['start'] = this.start;
		json['count'] = this.count;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.filter = json['filter'];
		this.start = json['start'];
		this.count = json['count'];
	}

	static SearchVotersRequestModel create(Map<String, dynamic> json) {
		var ret = new SearchVotersRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SearchVotersResponseModel extends PrivateAccessResponseModel {
	List<VoterModel> voters;

	SearchVotersResponseModel({ List<VoterModel> voters, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.voters = voters;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.voters != null) json['voters'] = this.voters.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		if (json['voters'] != null) this.voters = new List<Map<String, dynamic>>.from(json['voters']).map((l) => VoterModel.create(l)).toList();
	}

	static SearchVotersResponseModel create(Map<String, dynamic> json) {
		var ret = new SearchVotersResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SecretShareGroupModel {
	int id;
	int order;
	String label;
	SecretShareModel secretShare;

	SecretShareGroupModel({ int id, int order, String label, SecretShareModel secretShare }){ 
		this.id = id;
		this.order = order;
		this.label = label;
		this.secretShare = secretShare;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['order'] = this.order;
		json['label'] = this.label;
		json['secretShare'] = this.secretShare.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.order = json['order'];
		this.label = json['label'];
		this.secretShare = SecretShareModel.create(json['secretShare']);
	}

	static SecretShareGroupModel create(Map<String, dynamic> json) {
		var ret = new SecretShareGroupModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SecretShareModel {
	int id;
	int requireds;
	List<ShareModel> shares;

	SecretShareModel({ int id, int requireds, List<ShareModel> shares }){ 
		this.id = id;
		this.requireds = requireds;
		this.shares = shares;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['requireds'] = this.requireds;
		if (this.shares != null) json['shares'] = this.shares.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.requireds = json['requireds'];
		if (json['shares'] != null) this.shares = new List<Map<String, dynamic>>.from(json['shares']).map((l) => ShareModel.create(l)).toList();
	}

	static SecretShareModel create(Map<String, dynamic> json) {
		var ret = new SecretShareModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SendTokenByCredentialRequestModel extends PrivateAccessRequestModel {
	int credentialId;

	SendTokenByCredentialRequestModel({ int credentialId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.credentialId = credentialId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['credentialId'] = this.credentialId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.credentialId = json['credentialId'];
	}

	static SendTokenByCredentialRequestModel create(Map<String, dynamic> json) {
		var ret = new SendTokenByCredentialRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SendTokenByCredentialResponseModel extends PrivateAccessResponseModel {
	ResetPasswordStartResponseModel result;

	SendTokenByCredentialResponseModel({ ResetPasswordStartResponseModel result, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.result = result;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['result'] = this.result.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.result = ResetPasswordStartResponseModel.create(json['result']);
	}

	static SendTokenByCredentialResponseModel create(Map<String, dynamic> json) {
		var ret = new SendTokenByCredentialResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SendVoterFaceToFaceBallotBoxRequestModel extends PrivateAccessRequestModel {
	int ballotBoxId;
	int voterId;

	SendVoterFaceToFaceBallotBoxRequestModel({ int ballotBoxId, int voterId, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.ballotBoxId = ballotBoxId;
		this.voterId = voterId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['ballotBoxId'] = this.ballotBoxId;
		json['voterId'] = this.voterId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.ballotBoxId = json['ballotBoxId'];
		this.voterId = json['voterId'];
	}

	static SendVoterFaceToFaceBallotBoxRequestModel create(Map<String, dynamic> json) {
		var ret = new SendVoterFaceToFaceBallotBoxRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SendVoterFaceToFaceBallotBoxResponseModel extends PrivateAccessResponseModel {

	SendVoterFaceToFaceBallotBoxResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static SendVoterFaceToFaceBallotBoxResponseModel create(Map<String, dynamic> json) {
		var ret = new SendVoterFaceToFaceBallotBoxResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SessionModel {
	int id;
	DateTime startTime;
	DateTime finished;
	CredentialModel credential;

	SessionModel({ int id, DateTime startTime, DateTime finished, CredentialModel credential }){ 
		this.id = id;
		this.startTime = startTime;
		this.finished = finished;
		this.credential = credential;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		if (this.startTime != null) json['startTime'] = CommonConversion.date2String(this.startTime);
		if (this.finished != null) json['finished'] = CommonConversion.date2String(this.finished);
		json['credential'] = this.credential.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.startTime = CommonConversion.string2Date(json['startTime']);
		this.finished = CommonConversion.string2Date(json['finished']);
		this.credential = CredentialModel.create(json['credential']);
	}

	static SessionModel create(Map<String, dynamic> json) {
		var ret = new SessionModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ShareModel {
	int id;
	String label;
	int iterationCount;
	String pinSalt;
	String encSalt;
	String encryptedKey;

	ShareModel({ int id, String label, int iterationCount, String pinSalt, String encSalt, String encryptedKey }){ 
		this.id = id;
		this.label = label;
		this.iterationCount = iterationCount;
		this.pinSalt = pinSalt;
		this.encSalt = encSalt;
		this.encryptedKey = encryptedKey;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['label'] = this.label;
		json['iterationCount'] = this.iterationCount;
		json['pinSalt'] = this.pinSalt;
		json['encSalt'] = this.encSalt;
		json['encryptedKey'] = this.encryptedKey;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.label = json['label'];
		this.iterationCount = json['iterationCount'];
		this.pinSalt = json['pinSalt'];
		this.encSalt = json['encSalt'];
		this.encryptedKey = json['encryptedKey'];
	}

	static ShareModel create(Map<String, dynamic> json) {
		var ret = new ShareModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class SMSProviderModel extends ProviderModel {
	SMSProviderType type;
	String sender;
	ISMSProvider provider;

	SMSProviderModel({ SMSProviderType type, String sender, ISMSProvider provider, String key1, String key2, String key3, String key4, String key5 }) : super(key1: key1, key2: key2, key3: key3, key4: key4, key5: key5){ 
		this.type = type;
		this.sender = sender;
		this.provider = provider;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['type'] = this.type.value;
		json['sender'] = this.sender;
		json['provider'] = this.provider;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.type = new SMSProviderType(value: int.parse(json['type'].toString()));
		this.sender = json['sender'];
		this.provider = json['provider'];
	}

	static SMSProviderModel create(Map<String, dynamic> json) {
		var ret = new SMSProviderModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class StartPasswordSessionRequestModel extends StartSessionRequestModel {
	String passwordHash;
	String passwordHashUpperCase;
	String contact;
	CredentialType contactType;

	StartPasswordSessionRequestModel({ String passwordHash, String passwordHashUpperCase, String contact, CredentialType contactType, int organizationId }) : super(organizationId: organizationId){ 
		this.passwordHash = passwordHash;
		this.passwordHashUpperCase = passwordHashUpperCase;
		this.contact = contact;
		this.contactType = contactType;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['passwordHash'] = this.passwordHash;
		json['passwordHashUpperCase'] = this.passwordHashUpperCase;
		json['contact'] = this.contact;
		json['contactType'] = this.contactType.value;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.passwordHash = json['passwordHash'];
		this.passwordHashUpperCase = json['passwordHashUpperCase'];
		this.contact = json['contact'];
		this.contactType = new CredentialType(value: int.parse(json['contactType'].toString()));
	}

	static StartPasswordSessionRequestModel create(Map<String, dynamic> json) {
		var ret = new StartPasswordSessionRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class StartPasswordSessionResponseModel extends StartSessionResponseModel {
	AdministratorPermission adminPermissions;
	bool isUpperCase;

	StartPasswordSessionResponseModel({ AdministratorPermission adminPermissions, bool isUpperCase, CredentialModel credential, int sessionId, int challengeId, String challenge,  }) : super(credential: credential, sessionId: sessionId, challengeId: challengeId, challenge: challenge, ){ 
		this.adminPermissions = adminPermissions;
		this.isUpperCase = isUpperCase;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['adminPermissions'] = this.adminPermissions.value;
		json['isUpperCase'] = this.isUpperCase;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.adminPermissions = new AdministratorPermission(value: int.parse(json['adminPermissions'].toString()));
		this.isUpperCase = json['isUpperCase'];
	}

	static StartPasswordSessionResponseModel create(Map<String, dynamic> json) {
		var ret = new StartPasswordSessionResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class StartSessionRequestModel extends PublicAccessRequestModel {

	StartSessionRequestModel({ int organizationId }) : super(organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static StartSessionRequestModel create(Map<String, dynamic> json) {
		var ret = new StartSessionRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class StartSessionResponseModel extends PrivateAccessResponseModel {
	CredentialModel credential;
	int sessionId;

	StartSessionResponseModel({ CredentialModel credential, int sessionId, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.credential = credential;
		this.sessionId = sessionId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['credential'] = this.credential.toJson();
		json['sessionId'] = this.sessionId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.credential = CredentialModel.create(json['credential']);
		this.sessionId = json['sessionId'];
	}

	static StartSessionResponseModel create(Map<String, dynamic> json) {
		var ret = new StartSessionResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class TokenByLinkRequestModel extends RequestTokenRequestModel {
	int tokenId;
	String tokenHash;

	TokenByLinkRequestModel({ int tokenId, String tokenHash, int organizationId }) : super(organizationId: organizationId){ 
		this.tokenId = tokenId;
		this.tokenHash = tokenHash;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['tokenId'] = this.tokenId;
		json['tokenHash'] = this.tokenHash;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.tokenId = json['tokenId'];
		this.tokenHash = json['tokenHash'];
	}

	static TokenByLinkRequestModel create(Map<String, dynamic> json) {
		var ret = new TokenByLinkRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class TokenByLinkResponseModel extends RequestTokenResponseModel {
	String pkcs12;
	int iterationCount;
	String pinSalt;

	TokenByLinkResponseModel({ String pkcs12, int iterationCount, String pinSalt, int tokenId, String tokenDoubleHash, String link,  }) : super(tokenId: tokenId, tokenDoubleHash: tokenDoubleHash, link: link, ){ 
		this.pkcs12 = pkcs12;
		this.iterationCount = iterationCount;
		this.pinSalt = pinSalt;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['pkcs12'] = this.pkcs12;
		json['iterationCount'] = this.iterationCount;
		json['pinSalt'] = this.pinSalt;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.pkcs12 = json['pkcs12'];
		this.iterationCount = json['iterationCount'];
		this.pinSalt = json['pinSalt'];
	}

	static TokenByLinkResponseModel create(Map<String, dynamic> json) {
		var ret = new TokenByLinkResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ToogleCredentialRequestModel extends PrivateAccessRequestModel {
	int credentialId;
	bool enabled;

	ToogleCredentialRequestModel({ int credentialId, bool enabled, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.credentialId = credentialId;
		this.enabled = enabled;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['credentialId'] = this.credentialId;
		json['enabled'] = this.enabled;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.credentialId = json['credentialId'];
		this.enabled = json['enabled'];
	}

	static ToogleCredentialRequestModel create(Map<String, dynamic> json) {
		var ret = new ToogleCredentialRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ToogleCredentialResponseModel extends PrivateAccessResponseModel {

	ToogleCredentialResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static ToogleCredentialResponseModel create(Map<String, dynamic> json) {
		var ret = new ToogleCredentialResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class TooglePoolRequestModel extends PrivateAccessRequestModel {
	int poolId;
	bool enabled;

	TooglePoolRequestModel({ int poolId, bool enabled, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.poolId = poolId;
		this.enabled = enabled;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['poolId'] = this.poolId;
		json['enabled'] = this.enabled;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.poolId = json['poolId'];
		this.enabled = json['enabled'];
	}

	static TooglePoolRequestModel create(Map<String, dynamic> json) {
		var ret = new TooglePoolRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class TooglePoolResponseModel extends PrivateAccessResponseModel {

	TooglePoolResponseModel({ int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, );

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static TooglePoolResponseModel create(Map<String, dynamic> json) {
		var ret = new TooglePoolResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ToogleVoterPoolRequestModel extends PrivateAccessRequestModel {
	int userId;
	int poolId;
	bool enabled;

	ToogleVoterPoolRequestModel({ int userId, int poolId, bool enabled, int sessionId, int challengeId, String response, int organizationId }) : super(sessionId: sessionId, challengeId: challengeId, response: response, organizationId: organizationId){ 
		this.userId = userId;
		this.poolId = poolId;
		this.enabled = enabled;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['userId'] = this.userId;
		json['poolId'] = this.poolId;
		json['enabled'] = this.enabled;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.userId = json['userId'];
		this.poolId = json['poolId'];
		this.enabled = json['enabled'];
	}

	static ToogleVoterPoolRequestModel create(Map<String, dynamic> json) {
		var ret = new ToogleVoterPoolRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class ToogleVoterPoolResponseModel extends PrivateAccessResponseModel {
	int voterPoolId;

	ToogleVoterPoolResponseModel({ int voterPoolId, int challengeId, String challenge,  }) : super(challengeId: challengeId, challenge: challenge, ){ 
		this.voterPoolId = voterPoolId;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		json['voterPoolId'] = this.voterPoolId;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.voterPoolId = json['voterPoolId'];
	}

	static ToogleVoterPoolResponseModel create(Map<String, dynamic> json) {
		var ret = new ToogleVoterPoolResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadAdmin {
	String name;
	AdministratorPermission permissions;
	List<UploadUserCredential> credentials;
	List<DataValueModel> dataValues;

	UploadAdmin({ String name, AdministratorPermission permissions, List<UploadUserCredential> credentials, List<DataValueModel> dataValues }){ 
		this.name = name;
		this.permissions = permissions;
		this.credentials = credentials;
		this.dataValues = dataValues;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['name'] = this.name;
		json['permissions'] = this.permissions.value;
		if (this.credentials != null) json['credentials'] = this.credentials.map((e) => e.toJson()).toList();
		if (this.dataValues != null) json['dataValues'] = this.dataValues.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.name = json['name'];
		this.permissions = new AdministratorPermission(value: int.parse(json['permissions'].toString()));
		if (json['credentials'] != null) this.credentials = new List<Map<String, dynamic>>.from(json['credentials']).map((l) => UploadUserCredential.create(l)).toList();
		if (json['dataValues'] != null) this.dataValues = new List<Map<String, dynamic>>.from(json['dataValues']).map((l) => DataValueModel.create(l)).toList();
	}

	static UploadAdmin create(Map<String, dynamic> json) {
		var ret = new UploadAdmin();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadAdmins {
	String id;
	int organizationId;
	List<UploadAdmin> admins;

	UploadAdmins({ String id, int organizationId, List<UploadAdmin> admins }){ 
		this.id = id;
		this.organizationId = organizationId;
		this.admins = admins;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['organizationId'] = this.organizationId;
		if (this.admins != null) json['admins'] = this.admins.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.organizationId = json['organizationId'];
		if (json['admins'] != null) this.admins = new List<Map<String, dynamic>>.from(json['admins']).map((l) => UploadAdmin.create(l)).toList();
	}

	static UploadAdmins create(Map<String, dynamic> json) {
		var ret = new UploadAdmins();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadAdminsRequest {
	UploadAdmins admins;

	UploadAdminsRequest({ UploadAdmins admins }){ 
		this.admins = admins;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['admins'] = this.admins.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.admins = UploadAdmins.create(json['admins']);
	}

	static UploadAdminsRequest create(Map<String, dynamic> json) {
		var ret = new UploadAdminsRequest();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadAdminsResponse {
	DownloadAdmins invalids;

	UploadAdminsResponse({ DownloadAdmins invalids }){ 
		this.invalids = invalids;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['invalids'] = this.invalids.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.invalids = DownloadAdmins.create(json['invalids']);
	}

	static UploadAdminsResponse create(Map<String, dynamic> json) {
		var ret = new UploadAdminsResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadConfigurationItem {
	String id;
	OrganizationModel organization;

	UploadConfigurationItem({ String id, OrganizationModel organization }){ 
		this.id = id;
		this.organization = organization;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['organization'] = this.organization.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.organization = OrganizationModel.create(json['organization']);
	}

	static UploadConfigurationItem create(Map<String, dynamic> json) {
		var ret = new UploadConfigurationItem();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadConfigurationRequest {
	UploadConfigurationItem configuration;

	UploadConfigurationRequest({ UploadConfigurationItem configuration }){ 
		this.configuration = configuration;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['configuration'] = this.configuration.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.configuration = UploadConfigurationItem.create(json['configuration']);
	}

	static UploadConfigurationRequest create(Map<String, dynamic> json) {
		var ret = new UploadConfigurationRequest();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadConfigurationResponse {
	UploadConfigurationItem response;

	UploadConfigurationResponse({ UploadConfigurationItem response }){ 
		this.response = response;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['response'] = this.response.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.response = UploadConfigurationItem.create(json['response']);
	}

	static UploadConfigurationResponse create(Map<String, dynamic> json) {
		var ret = new UploadConfigurationResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadUserCredential {
	String contact;
	CredentialType type;
	String passwordHash;
	KeyPairInfoModel privateKey;

	UploadUserCredential({ String contact, CredentialType type, String passwordHash, KeyPairInfoModel privateKey }){ 
		this.contact = contact;
		this.type = type;
		this.passwordHash = passwordHash;
		this.privateKey = privateKey;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['contact'] = this.contact;
		json['type'] = this.type.value;
		json['passwordHash'] = this.passwordHash;
		json['privateKey'] = this.privateKey.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.contact = json['contact'];
		this.type = new CredentialType(value: int.parse(json['type'].toString()));
		this.passwordHash = json['passwordHash'];
		this.privateKey = KeyPairInfoModel.create(json['privateKey']);
	}

	static UploadUserCredential create(Map<String, dynamic> json) {
		var ret = new UploadUserCredential();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadVoter {
	String name;
	List<int> poolsId;
	List<int> poolWeighted;
	List<UploadUserCredential> credentials;
	List<DataValueModel> dataValues;

	UploadVoter({ String name, List<int> poolsId, List<int> poolWeighted, List<UploadUserCredential> credentials, List<DataValueModel> dataValues }){ 
		this.name = name;
		this.poolsId = poolsId;
		this.poolWeighted = poolWeighted;
		this.credentials = credentials;
		this.dataValues = dataValues;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['name'] = this.name;
		json['poolsId'] = this.poolsId;
		json['poolWeighted'] = this.poolWeighted;
		if (this.credentials != null) json['credentials'] = this.credentials.map((e) => e.toJson()).toList();
		if (this.dataValues != null) json['dataValues'] = this.dataValues.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.name = json['name'];
		if (json['poolsId'] != null) this.poolsId = new List<Map<String, dynamic>>.from(json['poolsId']).map((l) => int.parse(l.toString())).toList();
		if (json['poolWeighted'] != null) this.poolWeighted = new List<Map<String, dynamic>>.from(json['poolWeighted']).map((l) => int.parse(l.toString())).toList();
		if (json['credentials'] != null) this.credentials = new List<Map<String, dynamic>>.from(json['credentials']).map((l) => UploadUserCredential.create(l)).toList();
		if (json['dataValues'] != null) this.dataValues = new List<Map<String, dynamic>>.from(json['dataValues']).map((l) => DataValueModel.create(l)).toList();
	}

	static UploadVoter create(Map<String, dynamic> json) {
		var ret = new UploadVoter();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadVoters {
	String id;
	bool isToken;
	int organizationId;
	List<UploadVoter> voters;

	UploadVoters({ String id, bool isToken, int organizationId, List<UploadVoter> voters }){ 
		this.id = id;
		this.isToken = isToken;
		this.organizationId = organizationId;
		this.voters = voters;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['isToken'] = this.isToken;
		json['organizationId'] = this.organizationId;
		if (this.voters != null) json['voters'] = this.voters.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.isToken = json['isToken'];
		this.organizationId = json['organizationId'];
		if (json['voters'] != null) this.voters = new List<Map<String, dynamic>>.from(json['voters']).map((l) => UploadVoter.create(l)).toList();
	}

	static UploadVoters create(Map<String, dynamic> json) {
		var ret = new UploadVoters();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadVotersRequest {
	UploadVoters voters;

	UploadVotersRequest({ UploadVoters voters }){ 
		this.voters = voters;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['voters'] = this.voters.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.voters = UploadVoters.create(json['voters']);
	}

	static UploadVotersRequest create(Map<String, dynamic> json) {
		var ret = new UploadVotersRequest();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UploadVotersResponse {
	DownloadVoters invalids;

	UploadVotersResponse({ DownloadVoters invalids }){ 
		this.invalids = invalids;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['invalids'] = this.invalids.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.invalids = DownloadVoters.create(json['invalids']);
	}

	static UploadVotersResponse create(Map<String, dynamic> json) {
		var ret = new UploadVotersResponse();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UserAgentMonitorItemModel {
	String description;
	List<UserAgentMonitorSubItemModel> userAgents;
	int count;
	int votes;

	UserAgentMonitorItemModel({ String description, List<UserAgentMonitorSubItemModel> userAgents, int count, int votes }){ 
		this.description = description;
		this.userAgents = userAgents;
		this.count = count;
		this.votes = votes;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['description'] = this.description;
		if (this.userAgents != null) json['userAgents'] = this.userAgents.map((e) => e.toJson()).toList();
		json['count'] = this.count;
		json['votes'] = this.votes;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.description = json['description'];
		if (json['userAgents'] != null) this.userAgents = new List<Map<String, dynamic>>.from(json['userAgents']).map((l) => UserAgentMonitorSubItemModel.create(l)).toList();
		this.count = json['count'];
		this.votes = json['votes'];
	}

	static UserAgentMonitorItemModel create(Map<String, dynamic> json) {
		var ret = new UserAgentMonitorItemModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UserAgentMonitorItemRequestModel extends PublicAccessRequestModel {

	UserAgentMonitorItemRequestModel({ int organizationId }) : super(organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static UserAgentMonitorItemRequestModel create(Map<String, dynamic> json) {
		var ret = new UserAgentMonitorItemRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UserAgentMonitorItemResponseModel extends PublicAccessResponseModel {
	DateTime lastRefresh;
	List<UserAgentMonitorItemModel> devices;
	List<UserAgentMonitorItemModel> browsers;

	UserAgentMonitorItemResponseModel({ DateTime lastRefresh, List<UserAgentMonitorItemModel> devices, List<UserAgentMonitorItemModel> browsers,  }) : super(){ 
		this.lastRefresh = lastRefresh;
		this.devices = devices;
		this.browsers = browsers;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.lastRefresh != null) json['lastRefresh'] = CommonConversion.date2String(this.lastRefresh);
		if (this.devices != null) json['devices'] = this.devices.map((e) => e.toJson()).toList();
		if (this.browsers != null) json['browsers'] = this.browsers.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.lastRefresh = CommonConversion.string2Date(json['lastRefresh']);
		if (json['devices'] != null) this.devices = new List<Map<String, dynamic>>.from(json['devices']).map((l) => UserAgentMonitorItemModel.create(l)).toList();
		if (json['browsers'] != null) this.browsers = new List<Map<String, dynamic>>.from(json['browsers']).map((l) => UserAgentMonitorItemModel.create(l)).toList();
	}

	static UserAgentMonitorItemResponseModel create(Map<String, dynamic> json) {
		var ret = new UserAgentMonitorItemResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class UserAgentMonitorSubItemModel {
	String userAgent;
	EventAction eventAction;
	int count;
	int votes;

	UserAgentMonitorSubItemModel({ String userAgent, EventAction eventAction, int count, int votes }){ 
		this.userAgent = userAgent;
		this.eventAction = eventAction;
		this.count = count;
		this.votes = votes;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['userAgent'] = this.userAgent;
		json['eventAction'] = this.eventAction.value;
		json['count'] = this.count;
		json['votes'] = this.votes;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.userAgent = json['userAgent'];
		this.eventAction = new EventAction(value: int.parse(json['eventAction'].toString()));
		this.count = json['count'];
		this.votes = json['votes'];
	}

	static UserAgentMonitorSubItemModel create(Map<String, dynamic> json) {
		var ret = new UserAgentMonitorSubItemModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoteModel {
	int id;
	String encryptedVote;
	String openVote;
	String signature;
	String receiptRequest;
	String receiptResponse;
	String rejectionReason;
	int poolId;
	int voterId;
	int voterKeyId;
	DateTime voteDateTime;

	VoteModel({ int id, String encryptedVote, String openVote, String signature, String receiptRequest, String receiptResponse, String rejectionReason, int poolId, int voterId, int voterKeyId, DateTime voteDateTime }){ 
		this.id = id;
		this.encryptedVote = encryptedVote;
		this.openVote = openVote;
		this.signature = signature;
		this.receiptRequest = receiptRequest;
		this.receiptResponse = receiptResponse;
		this.rejectionReason = rejectionReason;
		this.poolId = poolId;
		this.voterId = voterId;
		this.voterKeyId = voterKeyId;
		this.voteDateTime = voteDateTime;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['encryptedVote'] = this.encryptedVote;
		json['openVote'] = this.openVote;
		json['signature'] = this.signature;
		json['receiptRequest'] = this.receiptRequest;
		json['receiptResponse'] = this.receiptResponse;
		json['rejectionReason'] = this.rejectionReason;
		json['poolId'] = this.poolId;
		json['voterId'] = this.voterId;
		json['voterKeyId'] = this.voterKeyId;
		if (this.voteDateTime != null) json['voteDateTime'] = CommonConversion.date2String(this.voteDateTime);
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.encryptedVote = json['encryptedVote'];
		this.openVote = json['openVote'];
		this.signature = json['signature'];
		this.receiptRequest = json['receiptRequest'];
		this.receiptResponse = json['receiptResponse'];
		this.rejectionReason = json['rejectionReason'];
		this.poolId = json['poolId'];
		this.voterId = json['voterId'];
		this.voterKeyId = json['voterKeyId'];
		this.voteDateTime = CommonConversion.string2Date(json['voteDateTime']);
	}

	static VoteModel create(Map<String, dynamic> json) {
		var ret = new VoteModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoteMonitorItemModel {
	int poolId;
	DateTime dateTime;
	int count;

	VoteMonitorItemModel({ int poolId, DateTime dateTime, int count }){ 
		this.poolId = poolId;
		this.dateTime = dateTime;
		this.count = count;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['poolId'] = this.poolId;
		if (this.dateTime != null) json['dateTime'] = CommonConversion.date2String(this.dateTime);
		json['count'] = this.count;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.poolId = json['poolId'];
		this.dateTime = CommonConversion.string2Date(json['dateTime']);
		this.count = json['count'];
	}

	static VoteMonitorItemModel create(Map<String, dynamic> json) {
		var ret = new VoteMonitorItemModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoteMonitorItemRequestModel extends PublicAccessRequestModel {

	VoteMonitorItemRequestModel({ int organizationId }) : super(organizationId: organizationId);

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
	}

	static VoteMonitorItemRequestModel create(Map<String, dynamic> json) {
		var ret = new VoteMonitorItemRequestModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoteMonitorItemResponseModel extends PublicAccessResponseModel {
	DateTime lastRefresh;
	List<VoteMonitorItemModel> itens;
	List<VoteMonitorPoolItemModel> pools;
	List<PoolResult> currentResult;

	VoteMonitorItemResponseModel({ DateTime lastRefresh, List<VoteMonitorItemModel> itens, List<VoteMonitorPoolItemModel> pools, List<PoolResult> currentResult,  }) : super(){ 
		this.lastRefresh = lastRefresh;
		this.itens = itens;
		this.pools = pools;
		this.currentResult = currentResult;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = super.toJson();
		if (this.lastRefresh != null) json['lastRefresh'] = CommonConversion.date2String(this.lastRefresh);
		if (this.itens != null) json['itens'] = this.itens.map((e) => e.toJson()).toList();
		if (this.pools != null) json['pools'] = this.pools.map((e) => e.toJson()).toList();
		if (this.currentResult != null) json['currentResult'] = this.currentResult.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		super.fromJson(json);
		this.lastRefresh = CommonConversion.string2Date(json['lastRefresh']);
		if (json['itens'] != null) this.itens = new List<Map<String, dynamic>>.from(json['itens']).map((l) => VoteMonitorItemModel.create(l)).toList();
		if (json['pools'] != null) this.pools = new List<Map<String, dynamic>>.from(json['pools']).map((l) => VoteMonitorPoolItemModel.create(l)).toList();
		if (json['currentResult'] != null) this.currentResult = new List<Map<String, dynamic>>.from(json['currentResult']).map((l) => PoolResult.create(l)).toList();
	}

	static VoteMonitorItemResponseModel create(Map<String, dynamic> json) {
		var ret = new VoteMonitorItemResponseModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoteMonitorPoolItemModel {
	int poolId;
	int enabledVoters;
	int disabledVoters;

	VoteMonitorPoolItemModel({ int poolId, int enabledVoters, int disabledVoters }){ 
		this.poolId = poolId;
		this.enabledVoters = enabledVoters;
		this.disabledVoters = disabledVoters;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['poolId'] = this.poolId;
		json['enabledVoters'] = this.enabledVoters;
		json['disabledVoters'] = this.disabledVoters;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.poolId = json['poolId'];
		this.enabledVoters = json['enabledVoters'];
		this.disabledVoters = json['disabledVoters'];
	}

	static VoteMonitorPoolItemModel create(Map<String, dynamic> json) {
		var ret = new VoteMonitorPoolItemModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoterEventModel {
	DateTime dateTime;
	String remoteIpAddress;
	int eventAction;
	String requestModel;
	String responseModel;
	String userName;
	String adminName;
	String userAgent;
	int userAgentTotal;
	int userAgentLogin;
	int userAgentVote;
	bool support;
	bool error;

	VoterEventModel({ DateTime dateTime, String remoteIpAddress, int eventAction, String requestModel, String responseModel, String userName, String adminName, String userAgent, int userAgentTotal, int userAgentLogin, int userAgentVote, bool support, bool error }){ 
		this.dateTime = dateTime;
		this.remoteIpAddress = remoteIpAddress;
		this.eventAction = eventAction;
		this.requestModel = requestModel;
		this.responseModel = responseModel;
		this.userName = userName;
		this.adminName = adminName;
		this.userAgent = userAgent;
		this.userAgentTotal = userAgentTotal;
		this.userAgentLogin = userAgentLogin;
		this.userAgentVote = userAgentVote;
		this.support = support;
		this.error = error;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		if (this.dateTime != null) json['dateTime'] = CommonConversion.date2String(this.dateTime);
		json['remoteIpAddress'] = this.remoteIpAddress;
		json['eventAction'] = this.eventAction;
		json['requestModel'] = this.requestModel;
		json['responseModel'] = this.responseModel;
		json['userName'] = this.userName;
		json['adminName'] = this.adminName;
		json['userAgent'] = this.userAgent;
		json['userAgentTotal'] = this.userAgentTotal;
		json['userAgentLogin'] = this.userAgentLogin;
		json['userAgentVote'] = this.userAgentVote;
		json['support'] = this.support;
		json['error'] = this.error;
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.dateTime = CommonConversion.string2Date(json['dateTime']);
		this.remoteIpAddress = json['remoteIpAddress'];
		this.eventAction = json['eventAction'];
		this.requestModel = json['requestModel'];
		this.responseModel = json['responseModel'];
		this.userName = json['userName'];
		this.adminName = json['adminName'];
		this.userAgent = json['userAgent'];
		this.userAgentTotal = json['userAgentTotal'];
		this.userAgentLogin = json['userAgentLogin'];
		this.userAgentVote = json['userAgentVote'];
		this.support = json['support'];
		this.error = json['error'];
	}

	static VoterEventModel create(Map<String, dynamic> json) {
		var ret = new VoterEventModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoterModel {
	bool connected;
	int userId;
	String name;
	List<PVoterCredentialModel> credentials;
	List<PVoterModel> pools;
	List<DataValueModel> dataValues;

	VoterModel({ bool connected, int userId, String name, List<PVoterCredentialModel> credentials, List<PVoterModel> pools, List<DataValueModel> dataValues }){ 
		this.connected = connected;
		this.userId = userId;
		this.name = name;
		this.credentials = credentials;
		this.pools = pools;
		this.dataValues = dataValues;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['connected'] = this.connected;
		json['userId'] = this.userId;
		json['name'] = this.name;
		if (this.credentials != null) json['credentials'] = this.credentials.map((e) => e.toJson()).toList();
		if (this.pools != null) json['pools'] = this.pools.map((e) => e.toJson()).toList();
		if (this.dataValues != null) json['dataValues'] = this.dataValues.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.connected = json['connected'];
		this.userId = json['userId'];
		this.name = json['name'];
		if (json['credentials'] != null) this.credentials = new List<Map<String, dynamic>>.from(json['credentials']).map((l) => PVoterCredentialModel.create(l)).toList();
		if (json['pools'] != null) this.pools = new List<Map<String, dynamic>>.from(json['pools']).map((l) => PVoterModel.create(l)).toList();
		if (json['dataValues'] != null) this.dataValues = new List<Map<String, dynamic>>.from(json['dataValues']).map((l) => DataValueModel.create(l)).toList();
	}

	static VoterModel create(Map<String, dynamic> json) {
		var ret = new VoterModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoterPoolModel {
	int id;
	int poolId;
	bool canVote;
	bool enabled;
	bool poolEnabled;
	String remoteIpAddress;
	String openVote;
	String receipt;
	DateTime voteDateTime;

	VoterPoolModel({ int id, int poolId, bool canVote, bool enabled, bool poolEnabled, String remoteIpAddress, String openVote, String receipt, DateTime voteDateTime }){ 
		this.id = id;
		this.poolId = poolId;
		this.canVote = canVote;
		this.enabled = enabled;
		this.poolEnabled = poolEnabled;
		this.remoteIpAddress = remoteIpAddress;
		this.openVote = openVote;
		this.receipt = receipt;
		this.voteDateTime = voteDateTime;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['id'] = this.id;
		json['poolId'] = this.poolId;
		json['canVote'] = this.canVote;
		json['enabled'] = this.enabled;
		json['poolEnabled'] = this.poolEnabled;
		json['remoteIpAddress'] = this.remoteIpAddress;
		json['openVote'] = this.openVote;
		json['receipt'] = this.receipt;
		if (this.voteDateTime != null) json['voteDateTime'] = CommonConversion.date2String(this.voteDateTime);
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.id = json['id'];
		this.poolId = json['poolId'];
		this.canVote = json['canVote'];
		this.enabled = json['enabled'];
		this.poolEnabled = json['poolEnabled'];
		this.remoteIpAddress = json['remoteIpAddress'];
		this.openVote = json['openVote'];
		this.receipt = json['receipt'];
		this.voteDateTime = CommonConversion.string2Date(json['voteDateTime']);
	}

	static VoterPoolModel create(Map<String, dynamic> json) {
		var ret = new VoterPoolModel();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

class VoterResult {
	int userId;
	String name;
	List<String> documents;
	List<PoolVoterResult> results;

	VoterResult({ int userId, String name, List<String> documents, List<PoolVoterResult> results }){ 
		this.userId = userId;
		this.name = name;
		this.documents = documents;
		this.results = results;
	}

	Map<String, dynamic> toJson() {
		final Map<String, dynamic> json = new Map<String, dynamic>();
		json['userId'] = this.userId;
		json['name'] = this.name;
		json['documents'] = this.documents;
		if (this.results != null) json['results'] = this.results.map((e) => e.toJson()).toList();
		return json;
	}

	fromJson(Map<String, dynamic> json) {
		this.userId = json['userId'];
		this.name = json['name'];
		if (json['documents'] != null) this.documents = new List<Map<String, dynamic>>.from(json['documents']).map((l) => l.toString()).toList();
		if (json['results'] != null) this.results = new List<Map<String, dynamic>>.from(json['results']).map((l) => PoolVoterResult.create(l)).toList();
	}

	static VoterResult create(Map<String, dynamic> json) {
		var ret = new VoterResult();
		if (json != null) ret.fromJson(json);
		return ret;
	}
}

